{*******************************************************}
{                                                       }
{       Game                                            }
{                                                       }
{       Copyright (C) 2009 IdeyaX studio                }
{                                                       }
{*******************************************************}

unit GMMap;

interface
     uses OpenGl,Windows,GMVars,GMUtilite,Textures,log,Classes,IDX_sound,fmoddyn,Math,SysUtils;

const
  MaxBulletsCount=100;
  CellW=32;
  CellH=32;

//     
const
   c_unit=1;
   c_building=2;
   c_tree=3;
   c_rock=4;// c - cell
   c_mon=5;


type Tbutton=record
     x,y:Integer;
     w,h:Integer;
     types:Byte;
     checked:Boolean;
     counter:Integer;
end;

type
  TBoom=record
  Alive:Boolean;
  x,y:Integer;
  currAnim:Integer;
  maxanim:integer;
  animSpeed:Integer;
  animD:integer;
end;



type
  Tbullet=record
  alive:Boolean;
  life:Integer;
  x,y:Single;
  dx,dy:Single;
  types:Byte;
  angle:Integer;
  whoIsShoot:Integer;
end;

type
  TMonster=object
  Alive:Boolean;
  Life:Integer;
  Types:Byte;
  PoSX,PoSY:Single;
  ToX,ToY:Single;
  angle:Integer;
  LopAngle:Integer;
  LopTick:Integer;
  LPoSX,LPoSY:Single;
  Index:Integer;

  reloadSpeed:Integer;
  reloadMaxSpeed:Integer;
  attackRadius:integer;

  procedure Procces;
  procedure Draw(Dx,Dy:Single);

end;

type
  TPlayer=object
  PoSX,PoSY:Single;
  ToX,ToY:Single;
  angle:Integer;
  LopAngle:Integer;
  LopTick:Integer;
  LPoSX,LPoSY:Single;

  reloadSpeed:Integer;
  reloadMaxSpeed:Integer;

  Life:Integer;

  NextPoint:Integer;
  PointAngle:Integer;

  procedure Procces;
  procedure Draw;
  end;

type
  TMapCell=record       // 
	mark:Byte;	// 
	layer:Byte;     //  - dwater,water,sand,dirt,grass
	x:Byte;		//     x
	y:Byte;		//     y
end;

type
   TmapObjCell=record //   
	types:Byte;   //  (, , , )
	number:Byte;  //   ,         5.
end;



type
   Tmap=object

  Width : Byte;
  Height: Byte;

  CurrentMap:integer;

  //  
  map:array of array of TMapCell;
  //  
  map_obj:array of array of TmapObjCell;

  CurrentWPointNumber:Integer;
   
  Texture:array[0..12] of cardinal;
  HeroTexture:array[0..20] of cardinal;
  TreeTexture:array[0..6] of Cardinal;
  RockTexture:array[0..6] of Cardinal;
  MenuTexture:array[0..10] of Cardinal;

   weapoint:array of record
                    x,y:Integer;
                    state:Byte; //1-  ,     
                    number:Integer; //  
                    end;


  procedure Init;
  procedure Load;
  procedure Close;
  procedure Draw;
  procedure Procces;
  procedure LoadMap(FName:string);
  procedure LoadLevel(Number:Integer);

  procedure AddNewWPoint;
  procedure AddWPoint(mx,my:Integer);
  end;

 type
   Thero=record
   x,y:Integer;
   end;

 type
 TVec3d = record
 X, Y, Z : single;
 end;

  TCamera = object
                x,y:Single;
                dx,dy:Single;
                procedure Update(mx,my:Single);
                procedure Procces;
            end;

type
  PSingleArray = ^TSingleArray;
  TSingleArray = array [0..0] of Single;


type
    TGCursor=record
    x,y:Integer;
    rotation:Single;
    scale:Single;
    visible:Boolean;
    state:Boolean;
    Selected:Integer;
    end;


var
 TextureUnits:array[0..12] of cardinal;
 TextureBoom:array[0..11] of cardinal;
 TextureBullets:array[0..12] of cardinal;

 Mymap:Tmap;
 MyCamera:Tcamera;

 Player:TPlayer;


 Monsters:array of TMonster;
 Bullets:array of Tbullet;
 Booms:array of TBoom;

 BulletsCount:Integer=-1;

 Buttons:array[0..4] of Tbutton;
 SelectButton,SelectedButton:Integer;
 CursorTex:Cardinal;
 TitulTex,NextLevelTex:Cardinal;

procedure ProccesGame;
procedure Render;
Procedure InitGame;
Procedure CloseGame;

procedure ResetBullets();
procedure ProccesBullets();
procedure AddBullet(x,y:Single;weaponId:Byte; Angle:Single; speed:Single; whoIsShoot:Integer);

function AddMonster(X,Y:Integer;Types:byte):Integer;
procedure ResetMonsters;
procedure ProccesMonsters;
procedure DrawMonsters;

procedure AddBoom(x,y:Integer; whoIsShoot:Integer);

implementation
        uses GMWindow;


procedure TMonster.Procces;
var
  rad:Integer;
begin
 case Types of
  0:
        begin
           Inc(LopTick);
           if LopTick>3 then
           begin
              Inc(LopAngle,3);
           end;

        end;

  1:
        begin

          LopAngle:=Round(AngleToPoint(Player.PoSX+MyCamera.x,Player.PoSY+MyCamera.y,PoSX,PoSY));
          rad:=Round(distance_dbl(Player.PoSX+MyCamera.x,Player.PoSY+MyCamera.y,PoSX,PoSY));

          if reloadSpeed>0 then Dec(reloadSpeed);
          if reloadSpeed<0 then reloadSpeed:=0;

          if (rad<=attackRadius) then
          begin


             if reloadSpeed=0 then
             begin
              AddBullet(PoSX,PoSY,0,LopAngle,5,Index);
              PlayEffect('shoot2.mp3');
              reloadSpeed:=reloadMaxSpeed;
             end;


          end;


        end;

  end;


end;

procedure TMonster.Draw(Dx,Dy:Single);
var
  rad:Integer;
begin
glBlend(1);

case Types of
 0:
  begin
     DrawTextureBox(PoSX-dx,PoSY-dy,64,64,Mymap.HeroTexture[8],$FFFFFF,255,True);
     DrawTextureBox(PoSX-dx,PoSY-dy,64,32,TextureUnits[1],$FFFFFF,255,True,LopAngle);
  end;

 1:
  begin
     DrawTextureBox(PoSX-dx,PoSY-dy,64,64,Mymap.HeroTexture[8],$FFFFFF,255,True);
     DrawTextureBox(PoSX-dx,PoSY-dy,64,32,TextureUnits[2],$FFFFFF,255,True,LopAngle);


//      rad:=Round(distance_dbl(Player.PoSX+MyCamera.x,Player.PoSY+MyCamera.y,PoSX,PoSY));
//      if (rad<=attackRadius) then  DrawCircle(PoSX-dx,PoSY-dy,attackRadius);//attackRadius);

     //dxfd

  end;

end;

 DrawRectangle2D(PoSX-dx-20,PoSY-dy+32,GetBoxSize(life,100,40),5,$FFFFFF,220,0,true,false);
 DrawRectangle2D(PoSX-dx-20,PoSY-dy+32,40,5,$0,220,0,false,false);


end;

function AddMonster(X,Y:Integer;Types:byte):Integer;
var
  i,k:Integer;
begin

   k:=-1;
  for i:=0 to High(Monsters) do
  if Monsters[i].alive=False then
  begin
   k:=i;
   Break;
  end;

  if k=-1 then
  begin
   k:=High(Monsters)+1;
   SetLength(Monsters,k+1);
  end;

  Monsters[k].PoSX:=x;
  Monsters[k].PoSY:=y;
  Monsters[k].Alive:=True;
  Monsters[k].Types:=Types;
  Monsters[k].Life:=100;
  Monsters[k].Index:=k;

  if Types=1 then
  begin
   Monsters[k].attackRadius:=400;
   Monsters[k].reloadSpeed:=60;
   Monsters[k].reloadMaxSpeed:=60;
  end;

  Result:=k;

end;

procedure ResetMonsters;
begin
  ZeroMemory(@Monsters,SizeOf(Monsters));
end;

procedure ProccesMonsters;
var
  i:Integer;
begin

  for i:=0 to High(Monsters) do
  if Monsters[i].alive then Monsters[i].Procces;

end;

procedure DrawMonsters();
var
  i:Integer;
begin



  for i:=0 to High(Monsters) do
  if Monsters[i].alive then Monsters[i].Draw(MyCamera.x,MyCamera.y);

end;

procedure AddBoom(x,y:Integer; whoIsShoot:Integer);
var
  i,k:Integer;
begin

  k:=-1;
  for i:=0 to High(Booms) do
  if Booms[i].alive=False then
  begin
   k:=i;
   Break;
  end;

  if k=-1 then
  begin
   k:=High(Booms)+1;
   SetLength(Booms,k+1);
  end;

  Booms[k].alive:=True;
  Booms[k].x:=x;//+trunc(MyCamera.x);
  Booms[k].y:=y;//+trunc(MyCamera.y);
  Booms[k].animSpeed:=0;
  Booms[k].maxanim:=11;
  Booms[k].animD:=2;
  Booms[k].currAnim:=0;
  
end;

procedure ProccesBooms();
var
  i:Integer;
begin

  for i:=0 to High(Booms) do
  if Booms[i].alive then
  begin
   inc(Booms[i].animSpeed);

   if Booms[i].animSpeed>= Booms[i].animD then
   begin
      Inc(Booms[i].currAnim);
      Booms[i].animSpeed:=0;
   end;

   if Booms[i].currAnim>=Booms[i].maxanim then Booms[i].alive:=False;

  end;


end;

procedure  DrawBooms();
var
  i:Integer;
begin
glBlend(2);
  for i:=0 to High(Booms) do
  if Booms[i].alive then
  begin
   DrawTextureBox(Booms[i].x-MyCamera.x,Booms[i].y-MyCamera.y,80,80,TextureBoom[Booms[i].currAnim],$FFFFFF,255,True);
  // DrawCircle(Bullets[i].x,Bullets[i].y,10);
  end;


end;
                                                         

procedure ResetBullets();
var
  i:Integer;
begin

  BulletsCount:=-1;
  ZeroMemory(@Bullets,SizeOf(Bullets));

end;


procedure AddBullet(x,y:Single;weaponId:Byte; Angle:Single; speed:Single; whoIsShoot:Integer);
var
  i,k:Integer;
begin

  k:=-1;
  for i:=0 to High(Bullets) do
  if Bullets[i].alive=False then
  begin
   k:=i;
   Break;
  end;

  if k=-1 then
  begin
   k:=High(Bullets)+1;
   SetLength(Bullets,k+1);
  end;

  speed:=speed*1.2;

  Bullets[k].alive:=True;
  Bullets[k].x:=x;
  Bullets[k].y:=y;
  Bullets[k].dx:=speed*sin(convert(Angle));
  Bullets[k].dy:=-speed*cos(convert(Angle));
  Bullets[k].types:=weaponId;
  Bullets[k].whoIsShoot:=whoIsShoot;
  Bullets[k].life:=100;
  Bullets[k].angle:=Round(Angle);
end;

procedure ProccesBullets();
var
  i,k:Integer;
begin

  for i:=0 to High(Bullets) do
  if Bullets[i].alive then
  begin
   Bullets[i].x:=Bullets[i].x+Bullets[i].dx;
   Bullets[i].y:=Bullets[i].y+Bullets[i].dy;
   Dec(Bullets[i].life);
   if Bullets[i].life=0 then Bullets[i].alive:=False;

   for k:=0 to High(Monsters) do
   if Monsters[k].Alive then
   begin

     ////////////////////////////////////////
     if (Bullets[i].whoIsShoot=-1) then
     begin
      if CircleVsCircle(Bullets[i].x,Bullets[i].y,2,Monsters[k].PoSX,Monsters[k].PoSY,16) then
      begin

        Monsters[k].Life:=Monsters[k].Life-(random(5)+25);

        if Monsters[k].Life<=0 then
        begin
         Monsters[k].Alive:=False;
         AddBoom(Round(Monsters[k].PoSX),Round(Monsters[k].PoSY),0);
         PlayEffect('boom.mp3');
        end;

        Bullets[i].alive:=False;
        Break;

      end;

     end;

     ////////////////////////////////////////
     if (Bullets[i].whoIsShoot>-1) then
     begin

      if CircleVsCircle(Bullets[i].x,Bullets[i].y,2,Player.PoSX+MyCamera.x,Player.PoSY+MyCamera.y,16) then
      begin

        Player.Life:=Player.Life-(random(5)+10);

        if Player.Life<=0 then
        begin
         Player.Life:=0;
          PlayEffect('boom.mp3');
          AddBoom(Round(Player.PoSX+MyCamera.x),Round(Player.PoSY+MyCamera.y),Bullets[i].whoIsShoot);

         GameStatus:=sDeath;
         Keys[MouseLB]:=false;

        end;

        Bullets[i].alive:=False;
        Break;

      end;

     end;


   end;

  end;


end;

procedure DrawBullets();
var
  i:Integer;
begin
glBlend(1);
  for i:=0 to High(Bullets) do
  if Bullets[i].alive then
  begin
   if Bullets[i].whoIsShoot<0 then
   DrawTextureBox(Bullets[i].x-MyCamera.x,Bullets[i].y-MyCamera.y,32,4,TextureBullets[0],$FFFFFF,255,True,Bullets[i].angle-90);

   if Bullets[i].whoIsShoot>-1 then
   DrawTextureBox(Bullets[i].x-MyCamera.x,Bullets[i].y-MyCamera.y,32,4,TextureBullets[0],$FF00FF,255,True,Bullets[i].angle-90);
  end;

end;


procedure Tcamera.Procces;
var
  spd,f:Single;
begin

    f:=6;

    if Keys[87] then
   begin
     Update(0,-f);
     //Keys[VK_Up]:=False;
   end;

    if Keys[83] then
   begin
     Update(0,f);
     //Keys[VK_Down]:=False;
   end;


    if Keys[65] then
   begin
     Update(-f,0);
     //Keys[VK_Left]:=False;
   end;


   if Keys[68] then
   begin
     Update(f,0);
    // Keys[VK_Right]:=False;
   end;


     spd:=4;
// if x<=dx then x:=x+spd;
// if x>=dx then x:=x-spd;
//
// if y<=dy then y:=y+spd;
// if y>=dy then y:=y-spd;

end;

procedure Tcamera.Update(mx,my:Single);
begin

   dx := x+ mx ;//- SCR2W;
   dy := y+ my ;//- SCR2H;

    if( dx < CellW ) then dx:= CellW;

    if( dy < CellW ) then dy:= CellW;

    if( dx > ((Mymap.Width*CellW) - SCRW) ) then
        dx:= (Mymap.Width*CellW) - SCRW;

    if( dy > ((Mymap.Height*CellH) - SCRH) ) then
        dy:= (Mymap.Height*CellH) - SCRH;

     x:=dx;
     y:=dy;

end;

procedure TPlayer.Draw;
begin
glBlend(1);
  DrawTextureBox(PoSX,PoSY,64,128,Mymap.HeroTexture[2],$FFFFFF,255,True,angle-180);
  DrawTextureBox(LPoSX,LPoSY,64,64,TextureUnits[0],$FFFFFF,255,True,LopAngle);

  DrawTextureBox(PoSX,PoSY,64,256,CursorTex,$FFFFFF,255,True,PointAngle-180);


 DrawRectangle2D(SCRW -220,SCRH-32,GetBoxSize(life,100,200),20,$FFFFFF,220,0,true,false);
 DrawRectangle2D(SCRW -220,SCRH-32,200,20,$0,220,0,false,false);


//  DrawRectangle2D(Mymap.weapoint[NextPoint].x-MyCamera.x,
//                  Mymap.weapoint[NextPoint].y-MyCamera.x,10,10,$FFFFFF,220,0,false,True);





 // DrawRectangle2D(PoSX,PoSY,50,50,$FFFFFF,220,PointAngle-180,false,True);



end;

procedure TPlayer.Procces;
var
  b,b1,c,f,an,step,step2:Single;
begin
    angle:=Round(AngleToPoint(SCR2W,SCR2H,MousePos.X,MousePos.Y));

    b:=convert(angle);
    c:=distance_dbl(SCR2W,SCR2H,MousePos.X,MousePos.Y);

   ToX:= SCR2W + c*Sin(b);
   ToY:= SCR2H - c*Cos(b);

   step:=distance_dbl(PoSX,PoSY,ToX,ToY);
   step2:=4;
   if step>4 then step:=4;

  if (abs(PoSX-ToX)>0) or (abs(PoSY-ToY)>0) then
  begin
    an:=Round(AngleToPoint(ToX,ToY,PoSX,PoSY));

    b:=convert(an);

    PoSX:= PoSX + step*Sin(b);
    PoSY:= PoSY - step*Cos(b);

  end;

  if (abs(PoSX-ToX)<=step) then PoSX:= ToX;
  if (abs(PoSY-ToY)<=step) then PoSY:= ToY;

  LPoSX:= PoSX + (-8)*Sin(b);
  LPoSY:= PoSY - (-8)*Cos(b);

    Inc(LopTick);

    if LopTick>2 then
    begin
     LopTick:=0;
     Inc(LopAngle,25);
    end;

     if reloadSpeed>0 then
     begin
       Dec(reloadSpeed);
     end;

     if reloadSpeed<0 then reloadSpeed:=0;

  if Keys[MouseLB] then
   begin

     if reloadSpeed=0 then
     begin
      AddBullet(PoSX+MyCamera.x,PoSY+MyCamera.y,0,angle-180,step2,-1);
      PlayEffect('shoot1.mp3');
      reloadSpeed:=reloadMaxSpeed;
     end;

     Keys[MouseLB]:=false;
   end;


 PointAngle:=Round(AngleToPoint(Player.PoSX+MyCamera.x,
                                Player.PoSY+MyCamera.y,
                                Mymap.weapoint[NextPoint].x,
                                Mymap.weapoint[NextPoint].y));




 c:= distance_dbl(Player.PoSX+MyCamera.x,
                  Player.PoSY+MyCamera.y,
                  Mymap.weapoint[NextPoint].x,
                  Mymap.weapoint[NextPoint].y);

  if c<50 then
  begin
    inc(NextPoint);
    if Mymap.weapoint[NextPoint].number>-1 then
    begin
     NextPoint:=0;
     GameStatus:=sVictory;
     Keys[MouseLB]:=false;
    end;
    PlayEffect('ChekPoint.mp3');

  end;

end;  


procedure  NewGame;
begin

end;



procedure Tmap.Procces;
begin
end;

procedure Tmap.LoadLevel(Number:Integer);
begin
  case Number of
  0:
   begin
      LoadMap('Level0.map');
   end;

   1:
   begin
      LoadMap('Level1.map');
   end;

  end;
end;

procedure Tmap.LoadMap(FName:string);
var
  F2:TextFile;
  F1: File of Byte;
  x,y,i,j:Integer;
  p0,p1,p2,p3,p4,dx,dy:integer;
  s:string;
begin

    ZeroMemory(@Booms,SizeOf(Booms));
    ZeroMemory(@Bullets,SizeOf(Bullets));
    ZeroMemory(@Monsters,SizeOf(Monsters));

    AssignFile(F1, 'data\levels\'+fName);
    Reset(F1);

    Read(F1, Width);
    Read(F1, Height);

    SetLength(map,Width+1,Height+1);
    SetLength(map_obj,Width+1,Height+1);

    for j:=0 to Height do
    for i:=0 to Width do
    begin
      map[i,j].mark:=0;
      map[i,j].layer:=0;
      map[i,j].x:=0;
      map[i,j].y:=0;

      map_obj[i,j].types:=0;
      map_obj[i,j].number:=0;
    end;

    // 
    for y:=0 to height do
    for x:=0 to Width do
    begin
     Read(f1,map[x,y].mark);//:,,.
     Read(f1,map[x,y].layer);//1-   :,.
     Read(f1,map[x,y].x);//2-  x
     Read(f1,map[x,y].y);//3-  y
    end;

    // 
    for y:=0 to height do
    for x:=0 to Width do
    begin
      Read(f1,map_obj[x,y].types);
      Read(f1,map_obj[x,y].number);
      p0:=map_obj[x,y].types;
      p1:=map_obj[x,y].number;

      if p0=c_mon then
      begin
        if (p1=2) then
        begin

           Player.PoSX:=0;
           Player.PoSY:=0;

           dx:=x*32-scr2w;
           dy:=y*32-scr2h;

           Player.reloadSpeed:=0;
           Player.reloadMaxSpeed:=3;
           Player.Life:=100;
           Player.NextPoint:=0;

           map_obj[x,y].types:=0;


            if( dx < CellW ) then dx:= CellW;
            if( dy < CellW ) then dy:= CellW;
            if( dx > ((Width*CellW) - SCRW) ) then
                dx:= (Width*CellW) - SCRW;
            if( dy > ((Height*CellH) - SCRH) ) then
                dy:= (Height*CellH) - SCRH;

             MyCamera.x:=dx;
             MyCamera.y:=dy;
         //AddMonster();

        end;

        if (p1=8) then
        begin
           AddMonster(x*32,y*32,1);

           map_obj[x,y].types:=0;

        end;

      end;


    end;
   CloseFile(F1);


    ZeroMemory(@weapoint,SizeOf(weapoint));
    CurrentWPointNumber:=-1;

    AssignFile(F2, 'data\levels\P'+fName);
    Reset(F2);
    p0:=0;
    while not Eof(F2) do
    begin

      readln(f2,s); p1:=StrToInt(s);
      readln(f2,s); p2:=StrToInt(s);
      readln(f2,s); p3:=StrToInt(s);
      readln(f2,s); p4:=StrToInt(s);

      if (p0<>p4) then
      begin
       AddNewWPoint;
       AddWPoint(p1,p2);
      end
      else
      AddWPoint(p1,p2);


      p0:=p4;

    end;

    CloseFile(F2);

end;

procedure TMap.AddNewWPoint;
begin
  Inc(CurrentWPointNumber);

end;

procedure TMap.AddWPoint(mx,my:Integer);
var
  i:Integer;
begin
   i:=High(weapoint)+1;
   SetLength(weapoint,i+1);
   weapoint[i].x:=mx;
   weapoint[i].y:=my;
   weapoint[i].state:=0;
   weapoint[i].number:=CurrentWPointNumber;
end;




procedure Tmap.Draw;
var
  x,y,k,r,n:Integer;
  mapx, mapy:Integer;
  map_xoff, map_yoff:Integer;
begin

 glBlend(1);

 k:=-1;


 mapx := Round(MyCamera.x) div CellW;
 mapy := Round(MyCamera.y) div CellH;

 map_xoff := Round(MyCamera.x) and (CellW-1);
 map_yoff := Round(MyCamera.y) and (CellH-1);


 for y:=0 to (SCRH div CellH)+1 do
 for x:=0 to (SCRW div CellW) do
 begin


   if ((mapx+x)<=Width) and ((mapy+y)<=Height) then
   //if cells[mapx+x,mapy+y].types<>0 then
    DrawTextureBox(x*CellW- map_xoff,
                   y*CellH- map_yoff,
                   CellW,CellH,
                   Texture[map[mapx+x,mapy+y].layer],
                   $FFFFFF,
                   255,
                   False,
                   0,
                   map[mapx+x,mapy+y].x,
                   map[mapx+x,mapy+y].y);
 end;


 for y:=0 to (SCRH div CellH)+2 do
 for x:=0 to (SCRW div CellW) do
 begin
    if ((mapx+x)<=Width) and ((mapy+y)<=Height) then
    begin
        r:=map_obj[mapx+x,mapy+y].types;
        n:=map_obj[mapx+x,mapy+y].number;

            if(r=c_tree) then
            begin

              // 
              DrawTextureBox(x*CellW- map_xoff-16,
                             y*CellH- map_yoff-(128-16),
                   64,128,
                   TreeTexture[n],
                   $FFFFFF,
                   255,
                   False,
                   0);


            end;

            if (r=c_rock) then
            begin

              // 
              DrawTextureBox(x*CellW- map_xoff-16,
                             y*CellH- map_yoff-(128-16),
                   64,128,
                   RockTexture[n],
                   $FFFFFF,
                   255,
                   False,
                   0);


            end;

            if (r=c_mon) then
            begin

              // 
              DrawTextureBox(x*CellW- map_xoff-16,
                             y*CellH- map_yoff-(64-16),
                   64,128,
                   HeroTexture[n],
                   $FFFFFF,
                   255,
                   False,
                   0);

            end;



    end;
 end;


 DrawRectangle2D(weapoint[Player.NextPoint].x-mycamera.x,
                 weapoint[Player.NextPoint].y-MyCamera.y,
                 20,20,$0000FF,255,0,False,True);

 // glDisable( GL_TEXTURE_2D );
//   y:=0;
//   for x:=0 to High(weapoint) do
//   begin
//
//
//    glBlend(1);
//
//     DrawRectangle2D(weapoint[x].x-mycamera.x,weapoint[x].y-MyCamera.y,20,20,$0000FF,255,0,False,True);
//
//       if weapoint[y].number=weapoint[x].number then
//       begin
//
//         DrawLine(weapoint[y].x-mycamera.x,weapoint[y].y-mycamera.y,
//                  weapoint[x].x-mycamera.x,weapoint[x].y-mycamera.y,
//                  1,
//                  255,255,255,255);
//
//       end;
//
//     //if y<>weapoint[x].number then
//     y:=x;
//
//   end;


 x:=round(MousePos.X+MyCamera.x) div CellW;
 y:=round(MousePos.Y+MyCamera.y) div CellH;


 //SText2D(MySysfont,inttostr(x)+','+inttostr(y),100,100,Rgb(255,0,0),255);


end;

procedure Tmap.Init;
var
  ix,iy:Integer;
 begin

 end;

procedure Tmap.Load;
var
  i:Integer;
begin
   CurrentMap:=0;

   LoadTexture('data\gfx\tile\dwater.png',Texture[0]);
   LoadTexture('data\gfx\tile\water.png',Texture[1]);
   LoadTexture('data\gfx\tile\sand.png',Texture[2]);
   LoadTexture('data\gfx\tile\mud.png',Texture[3]);
   LoadTexture('data\gfx\tile\grass.png',Texture[4]);
   LoadTexture('data\gfx\tile\dgrass.png',Texture[5]);
   LoadTexture('data\gfx\tile\stone.png',Texture[6]);

   LoadTexture('data\gfx\obj.png',HeroTexture[0]);
   LoadTexture('data\gfx\obj.png',HeroTexture[1]);

   for i:=0 to 4 do
   LoadTexture('data\gfx\obj\tree'+inttostr(i+1)+'.png',TreeTexture[i]);

   for i:=0 to 5 do
   LoadTexture('data\gfx\obj\rock'+inttostr(i+1)+'.png',RockTexture[i]);

   i:=2;
   LoadTexture('data\gfx\Units\player.png',HeroTexture[0+i]);
   LoadTexture('data\gfx\Units\EMan1.png',HeroTexture[1+i]);
   LoadTexture('data\gfx\Units\EMan2.png',HeroTexture[2+i]);

   LoadTexture('data\gfx\Units\FMan1.png',HeroTexture[3+i]);
   LoadTexture('data\gfx\Units\FMan2.png',HeroTexture[4+i]);
   LoadTexture('data\gfx\Units\FMan3.png',HeroTexture[5+i]);

   LoadTexture('data\gfx\Units\EHrono0.png',HeroTexture[6+i]);
   LoadTexture('data\gfx\Units\EHrono1.png',HeroTexture[7+i]);
   LoadTexture('data\gfx\Units\EHrono2.png',HeroTexture[8+i]);
   LoadTexture('data\gfx\Units\EHrono3.png',HeroTexture[9+i]);

   LoadTexture('data\gfx\Units\FHrono1.png',HeroTexture[10+i]);
   LoadTexture('data\gfx\Units\FHrono2.png',HeroTexture[11+i]);

   LoadTexture('data\gfx\Units\WHrono1.png',HeroTexture[12+i]);

end;

procedure Tmap.Close;
 begin
 end;


Procedure InitGame;
var
  i:Integer;
begin
 OpenLog;
  Randomize;

 Mymap.Load;
 Mymap.Init;
 ResetBullets;

 LoadTexture('data\gfx\bullet.png',TextureBullets[0]);
 LoadTexture('data\gfx\cursor.png',CursorTex);
 LoadTexture('data\gfx\vertuha.png',TextureUnits[0]);
 LoadTexture('data\gfx\HeadRadar.png',TextureUnits[1]);
 LoadTexture('data\gfx\HeadLauncher.png',TextureUnits[2]);

 LoadTexture('data\gfx\titul.jpg',TitulTex);
 LoadTexture('data\gfx\status.jpg',NextLevelTex);

 for i:=1 to 12 do
 if i<10 then
  LoadTexture('data\gfx\Boom\bm00'+inttostr(i)+'.jpg',TextureBoom[i-1])
 else
  LoadTexture('data\gfx\Boom\bm0'+inttostr(i)+'.jpg',TextureBoom[i-1]);




  Player.reloadSpeed:=0;
  Player.reloadMaxSpeed:=3;
 
 InitSoundEngine;

 PlayMusic('music.mp3');


end;


Procedure CloseGame;
var
  i:Integer;
begin
  FreeSoundEngine;
  CloseLog;

   for i:=0 to High(mymap.Texture) do
   glDeleteTextures(1,@mymap.Texture[i]);

   for i:=0 to High(TextureUnits) do
   glDeleteTextures(1,@TextureUnits[i]);


end;


procedure ProccesGame;
var
  i:integer;
begin
   if Keys[VK_ESCAPE] then PostQuitMessage(0);

/////////////////////////////////////////////////////
  if  GameStatus=sGMenu then
  begin
   if Keys[MouseLB] then
   begin
     Keys[MouseLB]:=false;
     GameStatus:=sGame;
     Mymap.CurrentMap:=0;
     Mymap.LoadLevel(0);
     Exit;
   end;

  end;

  if  GameStatus=sVictory then
  begin
   if Keys[MouseLB] then
   begin
     Keys[MouseLB]:=false;
     GameStatus:=sGame;
     inc(Mymap.CurrentMap);
     if  Mymap.CurrentMap>1 then Mymap.CurrentMap:=0;
     Mymap.LoadLevel(Mymap.CurrentMap);
     Exit;
   end;

  end;

  if  GameStatus=sDeath then
  begin
   if Keys[MouseLB] then
   begin
     Keys[MouseLB]:=false;
     GameStatus:=sGMenu;
     Mymap.LoadLevel(0);
     Exit;
   end;

  end;



  if GameStatus=sGame then
  begin
   MyCamera.Procces;
   ProccesBooms;
   Mymap.Procces;
   ProccesMonsters;
   Player.Procces;
   ProccesBullets;
  end;

end;

procedure Render;
 Var
 s:string;
 i,id,m,W:integer;
 Pt: TPoint;
 x,y:Single;
 mm,b,c:Single;
 angle:Integer;
 Data: PSingleArray;
 begin
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
 glPushMatrix;

   glDisable( GL_TEXTURE_2D );
  Enable2d(true);

   //

    if GameStatus=sVictory then
    begin
      DrawTextureBox(SCR2W,scr2h,512,512,NextLevelTex,$FFFFFF,255,True);
      SText2D(MySysfont,' !!!', SCR2W-250,scr2h-160,Rgb(255,255,255),255);

    end;

    if GameStatus=sDeath then
    begin
      DrawTextureBox(SCR2W,scr2h,512,512,NextLevelTex,$FFFFFF,255,True);
      SText2D(MySysfont,' !!!', SCR2W-250,scr2h-160,Rgb(255,255,255),255);

    end;

    if GameStatus=sGMenu then
    begin
      DrawTextureBox(0,0,SCRW,SCRH,TitulTex,$FFFFFF,255);
    end;

   if GameStatus=sGame then
   begin
    Mymap.Draw;
    DrawMonsters;
    DrawBullets;
    Player.Draw;
    DrawBooms;
   end;

  //SText2D(MySysfont,inttostr(Player.angle),10,20,Rgb(255,255,255),255);
  //SText2D(MySysfont,inttostr(MousePos.X)+' : '+inttostr(MousePos.Y),10,45,Rgb(255,0,0),255);





  //DrawCircle(Player.ToX,Player.ToY,30);
 //SText2D(MySysfont,inttostr(Mymap.xoffset)+' : '+inttostr(Mymap.yoffset),10,70,Rgb(255,0,0),255);
//
// if Keys[MouseLB] then
//  SText2D(MySysfont,FloatToStr(Cursor.scale),10,80,Rgb(255,0,0),255);



   //DrawRectangle2D(99,99,89,121,$FF00FF,255,0,true,false);

   //DrawRectangle2D(0,0,1024,768,$FF00FF,255,0,true,false);

  glEnable( GL_TEXTURE_2D );





  {for i:=0 to high(HeroBox) do
  begin
  DrawHSprite(HeroBox[i].X,HeroBox[i].Y+HeroBox[i].smy,HeroBox[i].AnimKadr,HeroBox[i].FlipMe);
  end;
  }

  (*
   glblend(1);
   glPushMatrix;
    glColor4f(1, 1, 1, 1);
   EnableTexture(mymap.Texture[0]);
   glTranslatef(100,100,0);
   glBegin(GL_QUADS);
   {glTexCoord2f(0, 1);    glVertex2f(0,0);
   glTexCoord2f(1, 1);    glVertex2f(0+87,0);
   glTexCoord2f(1, 0);         glVertex2f(0+87,0+119);
   glTexCoord2f(0, 1);    glVertex2f(0,0+119);

   		glTexCoord2f(0,1);  glVertex2f(0, 0);
		glTexCoord2f(1,1);  glVertex2f(0+87,0);
		glTexCoord2f(1,0);  glVertex2f(0+87, 0+119);
		glTexCoord2f(0,0);  glVertex2f(0,0+119);
      }
      id:=119;
   glTexCoord2f(0,1-(id)*0.001953125);  glVertex2f(0,0);
   glTexCoord2f(87*0.001953125,1-(id)*0.001953125);  glVertex2f(87,0);
   glTexCoord2f(87*0.001953125,1-0);  glVertex2f(87,119);
   glTexCoord2f(0,1-0);  glVertex2f(0,119);
   glEnd;
   glPopMatrix;

       {
   	glTexCoord2f(0,1);  glVertex2f(0, 0);
		glTexCoord2f(1,1);  glVertex2f(0+w,0);
		glTexCoord2f(1,0);  glVertex2f(0+w, 0+h);
		glTexCoord2f(0,0);  glVertex2f(0,0+h);
                 }

          *)
 {DrawLine2D(0,0,scrw,scrh,$0000FF);

  glBlend(2);
  glColor4f(1, 1, 1, 0.3);

 DrawTextureBox(500,500,64,64,mymap.TextureGrunt[0]);
  DrawTextureBox(400,400,64,64,mymap.TextureGrunt[1]);}
 Enable2d(false);
 //

 //SText2D(MySysfont,s,600,200,Rgb(255,255,255),255);

 glPopMatrix;
 SwapBuffers(GWDC);

 end;

end.






