unit GMUtilite;
///////////////////////////////////////
//   Unit : GMUtilite
//   Date : 02/04/2005
// Author : Amosow 'Gambit_OZ' Evgeniy
// e-Mail : greenrat@mail333.com
///////////////////////////////////////

interface
      uses Windows,OpenGl,GMVars,Math,SysUtils;

function ExtractFileDir(const FileName: string): string;

procedure Enable2d(A:boolean);
procedure glBlend(ID: Byte);
procedure VBL2(vsync : TVSyncMode);
procedure FreeSystemFont2D(font: DWORD); stdcall;
function GetTimer: integer;
function CreateSystemFont2D(AD:hDC;Face: PChar; W, H: integer): DWORD; stdcall;
procedure SText2D(font: DWORD; const str: string; X, Y, color: integer; Alpha : byte); stdcall;
procedure DrawRectangle2D(X, Y, Width, Height:Single; Color:integer; Alpha : byte=255;Angle:integer=0; Fill : boolean = false;Center:boolean=false);
function IntToStr(x: integer): string;
function StrToInt(const S: string): Integer;

procedure DrawTextureBox(x,y,w,h:single;
                         textId:cardinal;
                         color: integer;
                         Alpha : byte;
                         center:boolean=false;
                         angle:integer=0;
                         sprx:Integer=-1;
                         spry:Integer=-1);




function distance_dbl(x1,y1,x2,y2: double): double;
procedure CountFPS;
function GetTime: Integer;
procedure StartFPS;
procedure ProcessEnterName(Key: byte);
procedure ReadOptions(Name:string);


function CircleVsCircle(x0, y0, r0, x1, y1, r1:single):boolean;
function RectInRect(r1x,r1y,r1W,r1H,r2x,r2y,r2W,r2H:real):boolean;

procedure DrawTextureBox2(x,y,w,h:integer;textId:cardinal;center:boolean=false;angle:integer=0;FlipV:boolean=false);

function corrAngle( ang:single ):single;
function getRandomNumber( min, max:integer ):integer;

function getDistance( x1, y1:single; x2,y2:single ):single;

function PointInRect(X,Y:Single;Rx,RY,Rw,Rh:Single):Boolean;
function PointInCircle(X,Y:Single;Cx,Cy,Cr:Single):boolean;

function AngleToPoint(x1,y1,x2,y2:single):integer;
function convert(s:real):real;

function GetBoxSize(Value:Integer;MaxValue:Integer;BoxWidth:Integer ):Integer;

implementation
        uses IniFile,IDX_sound;

 function ExtractFileDir(const FileName: string): string;
var
  I: Integer;
begin
  I := LastDelimiter(PathDelim + DriveDelim,Filename);
  if (I > 1) and (FileName[I] = PathDelim) and
    (((FileName[I - 1] <> PathDelim) and (FileName[I-1] <> DriveDelim)) or
    (ByteType(FileName, I-1) = mbTrailByte)) then Dec(I);
  while (ByteType(FileName, I-1) = mbTrailByte) and (I > 0) do Dec(I);
  Result := Copy(FileName, 1, I);
end;


function GetBoxSize(Value:Integer;MaxValue:Integer;BoxWidth:Integer ):Integer;
var
  pr:Single;
begin
  pr:=0;
  if Value>MaxValue then
  begin
    Value:=MaxValue;
    pr:=100;
  end
  else
  pr:=Value/(MaxValue*0.01);

  Result:=Round(BoxWidth*(pr*0.01));

end;

function convert(s:real):real;
begin
result:= s * (pi / 180);
end;


function PointInRect(X,Y:Single;Rx,RY,Rw,Rh:Single):Boolean;
begin
  Result := ( X > RX ) and ( X < RX + RW ) and
            ( Y > RY ) and ( Y < RY + RH );
end;

function PointInCircle(X,Y:Single;Cx,Cy,Cr:Single):boolean;
begin
  Result := sqr( Cx - X ) + sqr( Cy - Y ) < sqr( Cr );
end;




function AngleToPoint(x1,y1,x2,y2:single):integer;
var
FAngle:real;
DlY,DlX:Integer;
begin
DlY := trunc(y1-y2);
DlX := trunc(x1-x2);

If DlX = 0 Then
begin
If DlY > 0 Then FAngle:= 3.14 Else FAngle:= 0;
end
Else
FAngle:= Arctan(Dly / DlX);
If Dly = 0 Then
If DlX > 0 Then FAngle:=1.57 Else FAngle:=4.71;
If (DlX > 0) And (Dly < 0) Then FAngle:= 1.57 - Abs(FAngle);
If (DlX > 0) And (Dly > 0) Then FAngle:= 1.57 + Abs(FAngle);
If (DlX < 0) And (Dly < 0) Then FAngle:= 4.71 + Abs(FAngle);
If (DlX < 0) And (Dly > 0) Then FAngle:= 4.71 - Abs(FAngle);

result:=trunc(FAngle*57.3248408);
end;




function getDistance( x1, y1:single; x2,y2:single ):single;
var
xd2,yd2,d:single;
begin
    xd2 := (x2-x1)*(x2-x1);
    yd2 := (y2-y1)*(y2-y1);
    d   := xd2+yd2;
    if(d<0.0) then d:=-d;
    result:=sqrt(d);
end;

function getRandomNumber( min, max:integer ):integer;
begin
    result:= random(max-min + 1) + min;
end;


procedure DrawTextureBox2(x,y,w,h:integer;textId:cardinal;center:boolean=false;angle:integer=0;FlipV:boolean=false);
var
rx,ry:single;
FlipN:array[0..3] of record
                          x,y:byte;
                          end;
begin
   glColor3f(1,1,1);
  glEnable( GL_TEXTURE_2D );
  glPushMatrix();
  glTranslatef(X,Y,0);
  if Angle<>0 then glrotatef(Angle,0,0,1);
  glBindTexture(GL_TEXTURE_2D, textId); // use floor

 FlipN[0].x:=0;FlipN[0].y:=1;
 FlipN[1].x:=1;FlipN[1].y:=1;
 FlipN[2].x:=1;FlipN[2].y:=0;
 FlipN[3].x:=0;FlipN[3].y:=0;

 if flipv then
 begin
 FlipN[0].x:=0;FlipN[0].y:=0;
 FlipN[1].x:=1;FlipN[1].y:=0;
 FlipN[2].x:=1;FlipN[2].y:=1;
 FlipN[3].x:=0;FlipN[3].y:=1;
 end;

 glBegin(GL_QUADS);
 if center then
  begin
      Rx:=W/2;
      Ry:=H/2;
  glTexCoord2f(FlipN[0].x,FlipN[0].y);  glVertex2f(-rx,-ry);
  glTexCoord2f(FlipN[1].x,FlipN[1].y);  glVertex2f(rx,-ry);
  glTexCoord2f(FlipN[2].x,FlipN[2].y);  glVertex2f(rx,ry);
  glTexCoord2f(FlipN[3].x,FlipN[3].y);  glVertex2f(-rx,ry);
   end
   else
   begin
  glTexCoord2f(FlipN[0].x,FlipN[0].y);  glVertex2f(0, 0);
  glTexCoord2f(FlipN[1].x,FlipN[1].y);  glVertex2f(0+w,0);
  glTexCoord2f(FlipN[2].x,FlipN[2].y);  glVertex2f(0+w, 0+h);
  glTexCoord2f(FlipN[3].x,FlipN[3].y);  glVertex2f(0,0+h);
   end;

  glEnd();
  glPopMatrix();
  glDisable( GL_TEXTURE_2D );
end;


function RectInRect(r1x,r1y,r1W,r1H,r2x,r2y,r2W,r2H:real):boolean;
begin
result:=
  ((R1X < R2X+R2W) and
  (R1X+R1W > R2X) and
  (R1Y < R2Y+R2H) and
  (R1Y+R1H > R2Y)) or
  ((R2X < R1X+R1W) and
  (R2X+R2W > R1X) and
  (R2Y < R1Y+R1H) and
  (R2Y+R2H > R1Y));

end;

function CircleVsCircle(x0, y0, r0, x1, y1, r1:single):boolean;
var
dx,dy,dr:single;
hyp:single;
begin
 dx:=x0-x1;
 dy:=y0-y1;
 dr:=r0+r1;

 hyp:= sqrt(dx*dx + dy*dy);
 result:=false;

 if (hyp<=dr) then result:=true;

end;


function ReadValueFromIniFile(Filename, Section, Key, Default: string):string; stdcall;
var ini : TIniFile;
begin
result:='';
if fileexists(Filename) then
begin
ini:=TIniFile.Create(Filename);
result:=ini.GetIniSectionKeyValue(Section,Key);

if result='-1' then result:=Default;
ini.Free;
end
else
  result:=Default;

end;


procedure ReadOptions(Name:string);
var
  ini : TIniFile;
  S:string;
  Loading:boolean;
  i,j,k,Myk:integer;
begin

 SCRW   :=strtoint(ReadValueFromIniFile(Name,'Screen','Width','800'));
 SCRH   :=strtoint(ReadValueFromIniFile(Name,'Screen','Height','600'));
 SCRBit :=strtoint(ReadValueFromIniFile(Name,'Screen','Bit','32'));
 SCRHZ  :=strtoint(ReadValueFromIniFile(Name,'Screen','Herz','60'));

 s:=ReadValueFromIniFile(Name,'Screen','Sync','1');
 if s='1' then Sync:=true else Sync:=false;

 s:=ReadValueFromIniFile(Name,'Screen','FullScreen','0');
 if s='1' then FullScreen:=true else FullScreen:=false;

 s:=ReadValueFromIniFile(Name,'Screen','CenterScreen','1');
 if s='1' then CenterScreen:=true else CenterScreen:=false;

 s:=ReadValueFromIniFile(Name,'Media','PlayMusic','0');
 if s='1' then playingmusic:=true else playingmusic:=false;

 s:=ReadValueFromIniFile(Name,'Media','PlaySound','0');
 if s='1' then playingsound:=true else playingsound:=false;

 SCR2W:=SCRW div 2;
 SCR2H:=SCRH div 2;;

end;




procedure ProcessEnterName(Key: byte);
begin
if  GameStatus in [sDeath,sVictory] then
begin

  case ord(key) of
      27 : ;
      13 :  begin
              if length(EnterName)=0 then EnterName:='';
              GameStatus:=sGMenu;
              //SetName(EnterName,999);
              //SaveHSTable;
              Keys[VK_RETURN]:=false;
            end;
      8 :
        begin
        if(EnterNamePos>0) then
          begin
          EnterName := copy(EnterName,1,EnterNamePos-1) +
                       copy(EnterName,EnterNamePos+1,length(EnterName));
          dec(EnterNamePos);
          end;
        end;
      else
        begin
        if(length(EnterName) < 20) then
          begin
          EnterName := copy(EnterName,1,EnterNamePos) +
                       chr(key) +
                       copy(EnterName,EnterNamePos+1,length(EnterName));
          inc(EnterNamePos);
          end;
        end;

    end;
 end;

end;



function GetTime: Integer;
var
  T : LARGE_INTEGER;
begin
  QueryPerformanceCounter(Int64(T));
  Result := Trunc(1000 * T.QuadPart / Timer_Freq.QuadPart);
end;

procedure StartFPS;
begin
  fps_time     := GetTime;
end;

procedure CountFPS;
begin
if fps_time <= GetTime then
  begin
    fps_time := GetTime + 1000;
    g_FPS    := fps_cur;
    fps_cur  := 0;
  end;
  inc(fps_cur);
end;


function distance_dbl(x1,y1,x2,y2: double): double;
begin
  result:=Sqrt(Sqr(x1-x2)+Sqr(y1-y2));
end;

//function ArcTan2(const Y, X: single): single;
//asm
// FLD     Y
// FLD     X
// FPATAN
// FWAIT
//end;



procedure DrawTextureBox(x,y,w,h:single;
                         textId:cardinal;
                         color: integer;
                         Alpha : byte;
                         center:boolean=false;
                         angle:integer=0;
                         sprx:Integer=-1;
                         spry:Integer=-1);
var
rx,ry,dx,dy:single;
spx:array[0..3]of Single;
spy:array[0..3]of Single;
begin
 if Alpha<>255 then
  glEnable(GL_BLEND);
 glcolor4ub(GetRValue(Color),GetGValue(Color),GetBValue(Color),Alpha);

  glEnable( GL_TEXTURE_2D );
  glPushMatrix();
  glTranslatef(X,Y,0);
  if Angle<>0 then glrotatef(Angle,0,0,1);
  glBindTexture(GL_TEXTURE_2D, textId); // use floor

  spx[0]:=0;
  spx[1]:=1;
  spx[2]:=1;
  spx[3]:=0;

  spy[0]:=1;
  spy[1]:=1;
  spy[2]:=0;
  spy[3]:=0;

  if (sprx>-1)and(spry>-1) then
  begin
//    spx:=sprx*0.25; //(1/128)*32=0.25;
//    spy:=spry*0.25;
//    spw:=0.25;
//    sph:=0.25;
//    sph1:=1-(spy+sph);
//    sph2:=1-(spy);

       dx:=sprx*0.25;
       dy:=spry*0.125;

      spx[0]:=dx;
      spx[1]:=dx+0.25;
      spx[2]:=dx+0.25;
      spx[3]:=dx;

      spy[0]:=1-(dy); //1-(dy+0.25)
      spy[1]:=1-(dy);
      spy[2]:=1-(dy+0.125);
      spy[3]:=1-(dy+0.125);


//      spx[0]:=dx;
//      spx[1]:=dx+0.25;
//      spx[2]:=dx+0.25;
//      spx[3]:=dx;
//
//      spy[0]:=(dy); //1-(dy+0.25)
//      spy[1]:=(dy);
//      spy[2]:=(dy+0.125);
//      spy[3]:=(dy+0.125);

  end;

 glBegin(GL_QUADS);
 if center then
  begin
          Rx:=W/2;
          Ry:=H/2;
      glTexCoord2f(spx[0],spy[0]);  glVertex2f(-rx,-ry);
      glTexCoord2f(spx[1],spy[1]);  glVertex2f(rx,-ry);
      glTexCoord2f(spx[2],spy[2]);  glVertex2f(rx,ry);
      glTexCoord2f(spx[3],spy[3]);  glVertex2f(-rx,ry);
   end
   else
   begin
      glTexCoord2f(spx[0],spy[0]);  glVertex2f(0, 0);
      glTexCoord2f(spx[1],spy[1]);  glVertex2f(0+w,0);
      glTexCoord2f(spx[2],spy[2]);  glVertex2f(0+w, 0+h);
      glTexCoord2f(spx[3],spy[3]);  glVertex2f(0,0+h);
   end;

  glEnd();
  glPopMatrix();
  if Alpha<>255 then glDisable(GL_BLEND);
  glDisable( GL_TEXTURE_2D );
end;


//   
function IntToStr(x: integer): string;
begin
Str(x, Result);
end;

function StrToInt(const S: string): Integer;
var
  E: Integer;
begin
  Val(S, Result, E);
end;


procedure DrawRectangle2D(X, Y, Width, Height:Single; Color:integer; Alpha : byte=255;Angle:integer=0; Fill : boolean = false;Center:boolean=false);
var
Rx,Ry:real;
begin

glPushMatrix;

glTranslatef(X,Y,0);

if Angle<>0 then glrotatef(Angle,0,0,1);
if Alpha<>255 then glEnable(GL_BLEND);

 if fill then
 begin

  glcolor4ub(GetRValue(Color),GetGValue(Color),GetBValue(Color),Alpha);
   glBegin(GL_QUADS);
  if center then
  begin
      Rx:=Width/2;
      Ry:=Height/2;
    glVertex2f(-rx,-ry);
    glVertex2f(rx,-ry);
    glVertex2f(rx,ry);
    glVertex2f(-rx,ry);
 end
 else
 begin
    glVertex2f(0,0);
    glVertex2f(0+Width,0);
    glVertex2f(0+Width,0+Height);
    glVertex2f(0,0+Height);
 end;

   glEnd;

 end else
 begin

  glcolor4ub(GetRValue(Color),GetGValue(Color),GetBValue(Color),Alpha);
   glBegin(GL_LINE_STRIP);
     if center then
  begin
      Rx:=Width/2;
      Ry:=Height/2;

    glVertex2f(-rx,-ry);
    glVertex2f(rx,-ry);
    glVertex2f(rx,ry);
    glVertex2f(-rx,ry);
    glVertex2f(-rx,-ry);
   end
   else
   begin

    glVertex2f(0,0);
    glVertex2f(0+Width,0);
    glVertex2f(0+Width,0+Height);
    glVertex2f(0,0+Height);
    glVertex2f(0,0-1);

   end;

   glEnd;

 end;
 glPopMatrix;

if Alpha<>255 then glDisable(GL_BLEND);
end;

procedure SText2D(font: DWORD; const str: string; X, Y, color: integer; Alpha : byte); stdcall;
begin
glPushMatrix();

if Alpha<>255 then
  glEnable(GL_BLEND);
 glcolor4ub(GetRValue(Color),GetGValue(Color),GetBValue(Color),Alpha);
 glRasterPos2f(X, Y);
 glListBase(font);
 glCallLists(Length(str), GL_UNSIGNED_BYTE, PChar(str));
if Alpha<>255 then
  glDisable(GL_BLEND);
glPopMatrix();
end;



function CreateSystemFont2D(AD:hDC;Face: PChar; W, H: integer): DWORD; stdcall;
var
 font : HFONT;
begin
Result := glGenLists(256);
font := CreateFont(H, W, 0, 0, 0, 0, 0, 0,RUSSIAN_CHARSET, OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS,
                   ANTIALIASED_QUALITY, FW_BOLD {or FF_DONTCARE or DEFAULT_PITCH}, Face);
SelectObject(AD, font);
wglUseFontBitmaps(AD, 0, 256, Result);
DeleteObject(font);
end;



function GetTimer: integer;
var
T : LARGE_INTEGER;
F : LARGE_INTEGER;
begin
QueryPerformanceFrequency(Int64(F));
QueryPerformanceCounter(Int64(T));
result := round(1000 * T.QuadPart / F.QuadPart);
end;



procedure FreeSystemFont2D(font: DWORD); stdcall;
begin
glDeleteLists(font, 256);
end;


procedure VBL2(vsync : TVSyncMode);
var
   i : Integer;
begin
   if WGL_EXT_swap_control then
   begin
      i := wglGetSwapIntervalEXT;
      case VSync of
         vsmSync    : if i<>1 then wglSwapIntervalEXT(1);
         vsmNoSync  : if i<>0 then wglSwapIntervalEXT(0);
      else
         Assert(False);
      end;
   end;

end;


//   //
procedure glBlend(ID: Byte);
begin
if ID = 0 then
 glDisable(GL_BLEND)
else
 begin
 glEnable(GL_BLEND);
  case ID of
   1 : glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
   2 : glBlendFunc(GL_SRC_ALPHA, GL_ONE);
   3 : glBlendFunc(GL_ZERO, GL_SRC_COLOR);
  end;
 end;
end;

procedure Enable2d(A:boolean);
begin
 if A then
 begin
  glDisable(GL_DEPTH_TEST);
  glMatrixMode(GL_PROJECTION);
  glPushMatrix;
  glLoadIdentity;
  gluOrtho2D(0,SCRW,SCRH,0);
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix;
  glLoadIdentity;
 end
 else
 begin
   glPopMatrix;
  glMatrixMode(GL_PROJECTION);
  glPopMatrix;
  glMatrixMode(GL_MODELVIEW);
  glEnable(GL_DEPTH_TEST);
 end;

 end;



//Corrects an angle (to the range of 0-360) return The corrected angle
function corrAngle( ang:single ):single;
var
ret:single;
begin
    ret:=ang;
    while(ret<   0.0) do ret:=ret+360.0;
    while(ret>=360.0) do ret:=ret-360.0;
    result:=ret;
end;

end.

