unit Use_3d;

interface

{
 0.008
 3d mesh model
 mms loader (can also save)
                Mefistofel
}

Uses Windows,OpenGl,Use_Geometry,SysUtils;

type
 TFace = array [0..2] of integer;{triangle Face}
 TVertex = array of TPoint;
 TFaces = Array of TFace;

{variable for Shadow volume}
 TShadow = record {for shadow geometry}
   SA,SB,SC,SD:TVertex;
   num_Shadow_Vertex:Integer;
 end;

{$REGION 'Mesh class'}
 TMesh = class
 private
 public
  Vertex:Array of TVertex; {array of vertex coords (array for animation)}
  Render_Vertex:TVertex;   {vertex coords for render}
  Face:TFaces;             {number each vertex in triangles}
  TexV:Array of TVect;     {texture coordinates}
  Tex:Array of TFace;      {number each texture vertex in triangles }
  Normal:Array of TPoint;  {normals fop each point}
  num_Vertex:cardinal;
  num_Faces:cardinal;
  num_Tex_Vertex:cardinal;
  num_anim:cardinal;
  Current_Anim:single;
  Mesh_Poz:TPozition;{Mesh changes}
  Poz:TPozition;{rotate Matrix+XYZ}
  Texture:cardinal;        {texture num}
  Textured,                {if true tren enable texture}
  Light,                   {if true then enable ligth, else - without}
  Blend,                   {if true - enable blending}
  Modulate:boolean;        {if true then modulate? else - decal}
  constructor Create();
  procedure Set_Clear_Normals();{Count normals from triangles}
  procedure Set_Pozition();{set mesh on there position}
  procedure Anim(L:single);overload;{animation between L and L+1 frame}
  procedure Anim(B,E,L:single);overload;{animation between L and L+1 frame}
  procedure AnimBetween(L:single;B,E:integer);{animation between L and N frame}
  procedure Render(tx:cardinal);    {render :) }
  procedure Rotate(Angs:TMatrix);   {rotate model for render}
  procedure Scale(F:Single);        {scale model for render}
  procedure Translate(T:TPoint);overload;
  procedure Poz_Multi(MPoz:TPozition);               {multi on poz matrix}
  procedure Translate(X,Y,Z:single);overload;
  procedure RenderRestore;
  procedure MeshMulti(MPoz:TPozition);
  procedure MeshRotate(Angs:TMatrix);
  procedure MeshScale(F:Single);                 {Scale all Mesh(and all mesh animation)}
  procedure MeshTranslate(T:TPoint);overload;    {translate all Mesh(and all mesh animation)}
  procedure MeshTranslate(X,Y,Z:single);overload;{translate all Mesh(and all mesh animation)}
  procedure MeshMirrorX;            {mirror for X all Mesh(and all mesh animation)}
  procedure MeshMirrorY;            {mirror for Y all Mesh(and all mesh animation)}
  procedure MeshMirrorZ;            {mirror for Z all Mesh(and all mesh animation)}
  procedure MeshRotate90X(side:boolean);{90 digrees rotation on X of all mesh forward or bacward(true side is 1 false side is -1)}
  procedure MeshRotate90Y(side:boolean);{90 digrees rotation on Y of all mesh forward or bacward(true side is 1 false side is -1)}
  procedure MeshRotate90Z(side:boolean);{90 digrees rotation on Z of all mesh forward or bacward(true side is 1 false side is -1)}
  procedure set_val(Var s:string;M,c:byte;var i:Cardinal; var j:Cardinal;var z:Cardinal; var L:Cardinal);
  procedure LoadFromMMSFile(FileName:String); {load geometry and animation from mms file}
  procedure Add_Load(Name:String);   {adding new geometry in this mesh}
  procedure SaveMMSFile(Name:String); {save mms format vith minimum faces,norms and tex}
  {extension}
  procedure Flat_Shadow_Render();{flat Shadow projection extension}
 { procedure Clear_Noramls();Make_Simple_Normals}
  procedure Render_Shadow_Mask();
 end;
{$ENDREGION}
{$REGION 'Additional Mesh - with shadows'}
 TShadow_Mesh = class(TMesh)
  private
  public
  Near_Face:array of TFace;
  //num_Near_Faces:integer;
  Face_Normal:Array of TPoint;  {normals fop each face(num_faces)}
  Face_Plane:Array of TPlane; {plane vars (num_faces)}
  illuminated:array of boolean;  {is that poly lighted}
  Light_Vector:TPoint;    {ligth Vector;}
  Shadow_Length:Single;   {Length of shadow volume}
  Shadow:TShadow;
  constructor Create();
  procedure Render(Tx:Cardinal);{set mesh on there position}
  procedure Set_Near_Faces();{begin procedure - neighbour set(need 1 time calculate)}
  procedure Calculate_Face_Illumination();{procedure calculate - is the face is lightin?}
  procedure Find_Volume();{create chadow volume geometry}
  procedure Draw_Volume();{draw in stensil}
  function Get_Volume():TShadow;{get Volume Geometry}
 end;
{$ENDREGION}

procedure Draw_Shadow_Volume(var Shadow:TShadow);
procedure Render_Shadow_Mask();

Var
  Man:TShadow_Mesh;

implementation

{Mesh}
{$REGION 'Create Mesh'}
constructor TMesh.Create();
begin
 num_Vertex:=5;
 num_Faces:=5;
 num_Tex_Vertex:=5;
 Textured:=true;
 Light:=true;
 Blend:=false;
 Modulate:=true;
 Texture:=255+Random(256);{ :)}
 SetLength(Vertex,5);
 SetLength(Face,5);
 SetLength(TexV,5);
 SetLength(Tex,5);
 SetLength(Normal,5);
 SetLength(Render_Vertex,num_vertex);
 Poz:=Default_TPozition;
 Mesh_Poz:=Default_TPozition;
end;
{$ENDREGION}
{$REGION 'Set pozition of mesh'}  
procedure TMesh.Set_Pozition();
begin
  glMultMatrixf(@Self.Poz);
end;
{$ENDREGION}
{$REGION 'MyRegion'} 
procedure TMesh.Set_Clear_Normals(); {Dont Work Wrong Normals}
Var i,j:integer;N:TPoint;
begin
 for i:=0 to num_Faces do
 begin
  N:=Get_Normal(Render_Vertex[Face[i][0]],
                Render_Vertex[Face[i][1]],
                Render_Vertex[Face[i][2]]);
  for j:=0 to 2 do
   begin
    Normal[Face[i][j]]:=N;
   end;
 end;
end;             
{$ENDREGION}
{$Region 'Animation'}
procedure TMesh.Anim(L:single);
Var i,a:cardinal;
begin
 if L<0 then L:=0;
 If L>num_Anim then L:=num_Anim;
 if (Current_Anim=L) then exit;
 a:= Trunc(L);
 If (L=a) then
  Render_Vertex:=copy(Vertex[a]) else
  For i:=0 to num_vertex do
   begin
    Render_Vertex[i]:=Between(Vertex[a][i],Vertex[a+1][i],L-a);
   end;
 Current_Anim:=L;
end;

procedure TMesh.Anim(B,E,L:single);
Var i,a1,a2:cardinal;
begin      {! 0<L<1 - between 0<K1,K2<num_Anim  -  !valid input}
 a1:= Trunc(B);
 a2:= Trunc(E);
 For i:=0 to num_vertex do
  begin
   Render_Vertex[i]:=Between(
        Between(Vertex[a1][i],Vertex[a1+1][i],B-a1),
        Between(Vertex[a2][i],Vertex[a2+1][i],E-a2),
        L);
  end;
end;

procedure TMesh.AnimBetween(L:single;B,E:integer);{animation between L and N frame}
Var i:cardinal;
begin
 if B<0 then B:=0;
 If B>num_Anim then B:=num_Anim;
 if E<0 then E:=0;
 If E>num_Anim+1 then E:=num_Anim+1;
 if L<0 then L:=0;
 if L>1 then L:=1;
 If (L=0) then
  Render_Vertex:=copy(Vertex[B]) else
  For i:=0 to num_vertex do
   begin
    Render_Vertex[i]:=Between(Vertex[B][i],Vertex[E][i],L);
   end;
end;
  
procedure TMesh.RenderRestore;
begin
 Render_Vertex:=copy(Vertex[0]);
 Current_Anim:=0;
end;
{$Endregion}
{$Region 'Render'}
procedure TMesh.Render(tx:cardinal);
Var i,j:integer;
begin
 if Self.Modulate then
    glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_Modulate) else
    glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_Decal);
 if Self.Textured then
  begin
   glEnable(GL_Texture_2d);
   glBindTexture(GL_Texture_2d,Tx);
  end;
 if Self.Blend then
  begin
   glEnable(GL_Blend);
   glDepthMask(false);
  end;
 if Self.Light then glEnable(GL_Lighting);
 glBegin(GL_Triangles);
 glColor4f(1,1,1,1);
 for i:=0 to num_Faces do
 for j:=0 to 2 do
  begin
   gltexcoord2fv(@TexV[Tex[i][j]]);
   glNormal3fv(@Normal[Face[i][j]]);
   glvertex3fv(@Render_Vertex[Face[i][j]]);
  end;
 glEnd;
 if Self.Blend then begin glDepthMask(true);end;
end;
{$EndRegion}
{$Region 'Mesh Transform'}
procedure TMesh.Scale(F:Single);
Var i,j:integer;
begin
 for i:=0 to num_Vertex do
  Render_Vertex[i]:=multi(Render_Vertex[i],F);
end;

procedure TMesh.Translate(T:TPoint);
Var i:integer;
begin
 for i:=0 to num_Vertex do
  Render_Vertex[i]:=plus(Render_Vertex[i],T);
end;

procedure TMesh.Translate(X,Y,Z:single);
Var i:integer;
begin
 for i:=0 to num_Vertex do
  Render_Vertex[i]:=plus(Render_Vertex[i],Point(X,Y,Z));
end;

procedure TMesh.Rotate(Angs:TMatrix);
Var i:integer;
begin
 for i:=0 to num_Vertex do
  Render_Vertex[i]:=multi(Angs,Render_Vertex[i]);
end;   

procedure TMesh.Poz_Multi(MPoz:TPozition);
Var i,j:integer;
begin
 for i:=0 to num_Vertex do
  begin
   Render_Vertex[i]:=multi(MPoz,Render_Vertex[i]);
  end;
end;

procedure TMesh.MeshMulti(MPoz:TPozition);
Var i,j:integer;
begin
 for j:=0 to num_Anim do
  for i:=0 to num_Vertex do
  begin
   Vertex[j][i]:=multi(MPoz,Vertex[j][i]);
  end;
 Mesh_Poz:=multi(Mesh_Poz,MPoz);
 Render_Vertex:=copy(Vertex[0]);
end;

procedure TMesh.MeshRotate(Angs:TMatrix);
Var i,j:integer;
begin
 for j:=0 to num_Anim do
 for i:=0 to num_Vertex do
  Vertex[j][i]:=multi(Angs,Vertex[j][i]);
 Mesh_Poz:=multi(Mesh_Poz,Pozition(Angs));
 Render_Vertex:=copy(Vertex[0]);
end;

procedure TMesh.MeshScale(F:Single);
Var i,j:integer;
begin
 for j:=0 to num_Anim do
 for i:=0 to num_Vertex do
  Vertex[j][i]:=multi(Vertex[j][i],F);
 Mesh_Poz:=multi(Mesh_Poz,Pozition(Matrix(F,0,0,0,F,0,0,0,F)));
 Render_Vertex:=copy(Vertex[0]);
end;

procedure TMesh.MeshTranslate(T:TPoint);
Var i,j:integer;
begin
 for j:=0 to num_Anim do
 for i:=0 to num_Vertex do
  Vertex[j][i]:=plus(Vertex[j][i],T);
 Mesh_Poz:=multi(Mesh_Poz,Pozition(Default_TMatrix,T));
 Render_Vertex:=copy(Vertex[0]);
end;

procedure TMesh.MeshTranslate(X,Y,Z:single);
Var i,j:integer;
begin
 for j:=0 to num_Anim do
 for i:=0 to num_Vertex do
  Vertex[j][i]:=plus(Vertex[j][i],Point(X,Y,Z));
 Mesh_Poz:=multi(Mesh_Poz,Pozition(Default_TMatrix,X,Y,Z));
 Render_Vertex:=copy(Vertex[0]);
end;

procedure TMesh.MeshMirrorX;
Var i,j:integer;Temp:integer;
begin
 for j:=0 to num_Anim do
 for i:=0 to num_Vertex do
  Vertex[j][i][0]:=-Vertex[j][i][0];
 for i := 0 to num_Faces do
 begin
  Temp:=Self.Face[i][0];
  Self.Face[i][0]:=Self.Face[i][2];
  Self.Face[i][2]:=Temp;
  Temp:=Self.Tex[i][0];
  Self.Tex[i][0]:=Self.Tex[i][2];
  Self.Tex[i][2]:=Temp;
 end;
 Render_Vertex:=copy(Vertex[0]);
 Current_Anim:=0;
end;

procedure TMesh.MeshMirrorY;
Var i,j:integer;Temp:integer;
begin
 for j:=0 to num_Anim do
 for i:=0 to num_Vertex do
  Vertex[j][i][1]:=-Vertex[j][i][1];
 for i := 0 to num_Faces do
 begin
  Temp:=Self.Face[i][0];
  Self.Face[i][0]:=Self.Face[i][2];
  Self.Face[i][2]:=Temp;
  Temp:=Self.Tex[i][0];
  Self.Tex[i][0]:=Self.Tex[i][2];
  Self.Tex[i][2]:=Temp;
 end;
 Render_Vertex:=copy(Vertex[0]);
 Current_Anim:=0;
end;

procedure TMesh.MeshMirrorZ;
Var i,j:integer;Temp:integer;
begin
 for j:=0 to num_Anim do
 for i:=0 to num_Vertex do
  Vertex[j][i][2]:=-Vertex[j][i][2];   
 for i := 0 to num_Faces do
 begin
  Temp:=Self.Face[i][0];
  Self.Face[i][0]:=Self.Face[i][2];
  Self.Face[i][2]:=Temp;
  Temp:=Self.Tex[i][0];
  Self.Tex[i][0]:=Self.Tex[i][2];
  Self.Tex[i][2]:=Temp;
 end;
 Render_Vertex:=copy(Vertex[0]);
 Current_Anim:=0;
end;

procedure TMesh.MeshRotate90X(side:boolean);{90 digrees rotation on X of all mesh forward or bacward(true side is 1 false side is -1)}
Var
 i,j,s:integer;
 Temp:Single;
begin
 if side then s:=-1 else s:=1;
 for j:=0 to num_Anim do
 begin
  for i:=0 to num_Vertex do
   begin
    Temp:=Vertex[j][i][2];
    Vertex[j][i][2]:=s*Vertex[j][i][1];
    Vertex[j][i][1]:=s*-Temp;
   end;
 end;
 Mesh_Poz:=multi(Mesh_Poz,Pozition(Rotate_X(90*s)));
 Render_Vertex:=copy(Vertex[0]);
 Current_Anim:=0;
end;

procedure TMesh.MeshRotate90Y(side:boolean);{90 digrees rotation on Y of all mesh forward or bacward(true side is 1 false side is -1)}
Var
 i,j,s:integer;
 Temp:Single;
begin
 if side then s:=-1 else s:=1;
 for j:=0 to num_Anim do
 begin
  for i:=0 to num_Vertex do
   begin
    Temp:=Vertex[j][i][2];
    Vertex[j][i][2]:=s*Vertex[j][i][0];
    Vertex[j][i][0]:=s*-Temp;
   end;
 end;                                  
 Mesh_Poz:=multi(Mesh_Poz,Pozition(Rotate_Y(90*s)));
 Render_Vertex:=copy(Vertex[0]);
 Current_Anim:=0;
end;

procedure TMesh.MeshRotate90Z(side:boolean);{90 digrees rotation on Z of all mesh forward or bacward(true side is 1 false side is -1)}
Var
 i,j,s:integer;
 Temp:Single;
begin
 if side then s:=-1 else s:=1;
 for j:=0 to num_Anim do
 begin
  for i:=0 to num_Vertex do
   begin
    Temp:=Vertex[j][i][1];
    Vertex[j][i][1]:=s*Vertex[j][i][0];
    Vertex[j][i][0]:=s*-Temp;
   end;
 end;                            
 Mesh_Poz:=multi(Mesh_Poz,Pozition(Rotate_X(90*s)));
 Render_Vertex:=copy(Vertex[0]);
 Current_Anim:=0;
end;
{$endRegion}
{$region 'download and save'}
procedure TMesh.set_val(Var s:string;M,c:byte;var i:Cardinal; var j:Cardinal;var z:Cardinal; var L:Cardinal);
begin
 if (S<>'') then
  case m of
   1:case c of
      0:begin     {vertex nums}
         num_Vertex:=StrToInt(S);
         num_anim:=L;
         SetLength(Vertex,num_Anim+1);
         SetLength(Vertex[L],num_Vertex+1);
         SetLength(Normal,num_Vertex+1);
         i:=0;
         z:=0;
        end;
      1:begin Vertex[L][i][0]:=StrToFloat(S); end; {x}
      2:begin Vertex[L][i][1]:=StrToFloat(S); end; {y}
      3:begin Vertex[L][i][2]:=StrToFloat(S);
        if (i<num_Vertex) then i:=i+1;end; {z}
      4:begin Face[j][0]:=StrToInt(S)-1; end; {a}
      5:begin Face[j][1]:=StrToInt(S)-1; end; {b}
      6:begin Face[j][2]:=StrToInt(S)-1;
        if (j<num_Faces) then j:=j+1;end; {c}
      10:begin      {faces num}
          num_Faces:=StrToInt(S)-1;       {face count in program begin from 0!!!!!!!!!!!!!!!!!1}
          SetLength(Face,num_Faces+1);
          j:=0;
         end;
     end;
   3:case c of
      0:begin      {textures num}
         num_Tex_Vertex:=StrToInt(S);
         SetLength(TexV,num_Tex_Vertex+1);
         SetLength(Tex,num_Faces+1);
         i:=0;j:=0;
         L:=L+1;
        end;
      1:begin texV[i][0]:=StrToFloat(S); end; {x}
      2:begin texV[i][1]:=StrToFloat(S);
        if (i<num_Tex_Vertex) then i:=i+1;end; {y}
      4:begin tex[j][0]:=StrToInt(S)-1; end; {a}
      5:begin tex[j][1]:=StrToInt(S)-1; end; {b}
      6:begin tex[j][2]:=StrToInt(S)-1;
        if (j<num_Faces) then j:=j+1;end;{c}
     end;
   4:case c of
      1:begin Normal[i][0]:=StrToFloat(S); end; {x}
      2:begin Normal[i][1]:=StrToFloat(S); end; {y}
      3:begin Normal[i][2]:=StrToFloat(S);
        if (i<num_Vertex) then i:=i+1;end; {z}
     end;
  end;
 S:='';
end;

procedure TMesh.LoadFromMMSFile(FileName:String);
Var
 F:File of Char;
 i,j,z,l:cardinal;{counters}
 S:string;
 a:char;
 Mode:byte;{trigger}    {0-none       1-Vertex num(vc)}
                        {2-Faces num  3-textures num  }
                        {4-normals                    }
 cnt:byte;              {0- num       1-x 2-y 3-z     }
                        {4-a 5-b 6-c                  }
begin
 mode:=0;
 cnt:=0;
 i:=0;
 j:=0;
 z:=0;
 l:=0;
 AssignFile(F,FileName);
 Reset(F);
 S:='';
 Repeat
  a:='q';
  read(F,a);
  Case a of
   'e','E','0','1'..'9','-':S:=S+a;{numbers (with minus and point for float)}
   '.',',':S:=S+',';
   'X','x':begin set_val(s,Mode,cnt,i,j,z,l);cnt:=1;end;
   'Y','y':begin set_val(s,Mode,cnt,i,j,z,l);cnt:=2;end;
   'Z','z':begin set_val(s,Mode,cnt,i,j,z,l);cnt:=3;end; {float vertex and texture coords}
   'A','a':begin set_val(s,Mode,cnt,i,j,z,l);cnt:=4;end;
   'B','b':begin set_val(s,Mode,cnt,i,j,z,l);cnt:=5;end;
   'C','c':begin set_val(s,Mode,cnt,i,j,z,l);cnt:=6;end; {int faces and textures for them}
   'V','v':begin set_val(s,Mode,cnt,i,j,z,l);mode:=1;cnt:=0;end;{prefix col vertex}
   'F','f':begin set_val(s,Mode,cnt,i,j,z,l);mode:=1;cnt:=10;end;{prefix col faces}
   'N','n':begin set_val(s,Mode,cnt,i,j,z,l);if (mode<>4) then i:=0;mode:=4;cnt:=0;end;{prefix normal}
   'T','t':begin set_val(s,Mode,cnt,i,j,z,l);mode:=3;cnt:=0;end;{prefix texture}
   'q','Q':begin set_val(s,Mode,cnt,i,j,z,l);cnt:=0;mode:=3;end;{part of 'Tex' word}
   else begin set_val(s,Mode,cnt,i,j,z,l);cnt:=0;end;
  end;
 Until Eof(F);
 CloseFile(F);
 for i:=0 to num_Vertex do
  Normal[i]:=Normalize(Normal[i]);{ }
 SetLength(Render_Vertex,num_vertex+1);
 Render_Vertex:=copy(Vertex[0]);  
 Current_Anim:=0;
end;

procedure TMesh.Add_Load(Name:String);
Var LoadMesh:TMesh;
i,z,q:Integer;
begin
 LoadMesh:=TMesh.Create;
 LoadMesh.LoadFromMMSFile(Name);
 SetLength(self.Normal,self.num_Vertex+LoadMesh.num_Vertex+1);
 For z:=0 to self.num_anim do
  begin
   SetLength(self.Vertex[z],self.num_Vertex+LoadMesh.num_Vertex+1);
   q:=z;
   for i:=0 to LoadMesh.num_Vertex do
    begin
     if q>LoadMesh.num_anim then q:=LoadMesh.num_anim;{esli animacii v dobavlyaemom meshe men`she}
     self.Vertex[z][i+self.num_Vertex]:=LoadMesh.Vertex[q][i];
    end;
  end;
 SetLength(self.Tex ,self.num_Faces+LoadMesh.num_Faces+1);
 SetLength(self.Face,self.num_Faces+LoadMesh.num_Faces+1);
 For i:=0 to LoadMesh.num_Faces do
  begin
   Face[i+self.num_Faces][0]:=LoadMesh.Face[i][0]+self.num_Vertex;
   Face[i+self.num_Faces][1]:=LoadMesh.Face[i][1]+self.num_Vertex;
   Face[i+self.num_Faces][2]:=LoadMesh.Face[i][2]+self.num_Vertex;
   Tex[i+self.num_Faces][0]:=LoadMesh.Tex[i][0]+self.num_Tex_Vertex;
   Tex[i+self.num_Faces][1]:=LoadMesh.Tex[i][1]+self.num_Tex_Vertex;
   Tex[i+self.num_Faces][2]:=LoadMesh.Tex[i][2]+self.num_Tex_Vertex;
  end;
 SetLength(TexV,num_Tex_Vertex+LoadMesh.num_Tex_Vertex+1);
 For i:=0 to LoadMesh.num_Tex_Vertex do
  begin
   TexV[i+self.num_Tex_Vertex]:=LoadMesh.TexV[i];
  end;
 num_Vertex:=num_Vertex+LoadMesh.num_Vertex;
 num_Tex_Vertex:=num_Tex_Vertex+LoadMesh.num_Tex_Vertex;
 num_Faces:=num_Faces+LoadMesh.num_Faces;
 Render_Vertex:=copy(Vertex[0]);  
 Current_Anim:=0;
{}
end;

procedure TMesh.SaveMMSFile(name:string);
Var
 F:File of Char;
 i,j:cardinal;{counters}
 a:char;
 procedure Save_str(str:string);
 var q:byte;
  begin
   for q:=1 to Length(str) do
    begin
     a:=str[q];
     Write(F,a);
    end;
  end;
begin
 AssignFile(F,Name);
 Rewrite(F);
 for j:=0 to num_anim do
 begin
 Save_str(' V');
 Save_str(intToStr(num_Vertex));
 Save_str(' F');
 Save_str(intToStr(num_Faces));
 Save_str(#13);
  for i:=0 to num_Vertex do
  begin
   Save_str('X'+floatToStrF(Vertex[j][i][0],ffGeneral,5,2));
   Save_str('Y'+floatToStrF(Vertex[j][i][1],ffGeneral,5,2));
   Save_str('Z'+floatToStrF(Vertex[j][i][2],ffGeneral,5,2));
   Save_str(#13);
  end;
 Save_str(#13);
 if (j<num_anim) then Save_str(' tq'+intToStr(num_tex_vertex));
 end; 
 for i:=0 to num_Faces do
 begin
  Save_str(' a'+intToStr(Face[i][0]+1));
  Save_str(' b'+intToStr(Face[i][1]+1));
  Save_str(' c'+intToStr(Face[i][2]+1));
  Save_str(#13);
 end;
 Save_str(#13);
 Save_str(' tq'+intToStr(num_tex_vertex));
 Save_str(#13);
 for i:=0 to num_tex_vertex do
 begin
  Save_str('tx'+floatToStrF(TexV[i][0],ffGeneral,7,2));
  Save_str('ty'+floatToStrF(TexV[i][1],ffGeneral,7,2));
   Save_str(#13);
 end;
 Save_str(#13);
 for i:=0 to num_Faces do
 begin
  Save_str('ta'+intToStr(Tex[i][0]+1));
  Save_str('tb'+intToStr(Tex[i][1]+1));
  Save_str('tc'+intToStr(Tex[i][2]+1));
 end;
 for i:=0 to num_Vertex do
 begin
  Save_str('NX'+floatToStrF(Normal[i][0],ffGeneral,7,2));
  Save_str('NY'+floatToStrF(Normal[i][1],ffGeneral,7,2));
  Save_str('NZ'+floatToStrF(Normal[i][2],ffGeneral,7,2));
 end;                
 CloseFile(F);
end;
{$endRegion}
{$REGION 'Render_Shadow_Mask'}
procedure TMesh.Render_Shadow_Mask();
begin
 glEnable(GL_STENCIL_TEST);
 glEnable(GL_Blend);
 glBlendFunc( GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA );
 glColor4f(0,0,0,0.5);
 glStencilFunc( GL_NOTEQUAL, 0, 7 );
 glStencilOp(GL_KEEP,GL_KEEP,GL_KEEP);
 glDisable(GL_Depth_Test);
 glPushMatrix();
 glLoadIdentity();
 glBegin(GL_QUADS);
  glVertex3f(-10,-10,0);
  glVertex3f( 10,-10,0);
  glVertex3f( 10, 10,0);
  glVertex3f(-10, 10,0);
 glend;        { }
 glPopMatrix();
 glEnable(GL_Depth_Test);
 GlDepthMask(true);        
 glDisable(GL_Blend);
 glDisable(GL_STENCIL_TEST);
end;
{$ENDREGION}
{------------  Addition for flat Shadows  --------------}
{$REGION 'Fla shadows'}
procedure TMesh.Flat_Shadow_Render();{without view matrix}
Var i,j:integer;
begin
 glDisable(gl_Lighting);
 glDisable(gl_Texture_2d);
 glBegin(GL_Triangles);
 glColor4f(0,0,0,1);
 for i:=0 to num_Faces do
 for j:=0 to 2 do
  begin
   //glNormal3fv(@Normal[Face[i][j]]);
   glvertex3fv(@Render_Vertex[Face[i][j]]);
  end;
 glEnd;
end;   
{$ENDREGION}
{shadow mesh}
{$REGION 'Shadow Mesh Create'}
constructor TShadow_Mesh.Create();
begin
 //standart create
 num_Vertex:=5;
 num_Faces:=5;
 num_Tex_Vertex:=5;
 Textured:=true;
 Light:=true;
 Blend:=false;
 Modulate:=true;
 Texture:=255+Random(256);
 SetLength(Vertex,5);
 SetLength(Face,5);
 SetLength(TexV,5);
 SetLength(Tex,5);
 SetLength(Normal,5);
 SetLength(Render_Vertex,num_vertex);
 Poz:=Default_TPozition;
 Mesh_Poz:=Default_TPozition;
 //Shadow properties
 Self.Light_Vector:=Point(0,0,-1);
 Shadow_Length:=30;
end;
{$ENDREGION}
{$REGION 'Shadow_Mesh Render'}
procedure TShadow_Mesh.Render(Tx:Cardinal);{set mesh on there position}
Var i,j:integer;
N:TPoint;
begin
 if Self.Modulate then
    glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_Modulate) else
    glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_Decal);
 if Self.Textured then
  begin
   glEnable(GL_Texture_2d);
   glBindTexture(GL_Texture_2d,Tx);
  end;
 if Self.Blend then
  begin
   glEnable(GL_Blend);
   glDepthMask(false);
  end;
 if Self.Light then glEnable(GL_Lighting);
// glColor4f(1,1,1,1);
{ glEnableClientState(GL_Vertex_Array);
 glEnableClientState(GL_TEXTURE_COORD_ARRAY);
 glEnableClientState(GL_NORMAL_ARRAY);
 glNormalPointer(GL_Float,0,@Self.Face_Normal[0]);
 glTexCoordPointer(2, GL_FLOAT, 0, @Self.TexV[0]); 
 glVertexPointer(3,GL_Float,0,@Self.Render_Vertex[0]);
 glDrawElements(GL_TRIANGLES, Self.num_Faces, GL_UNSIGNED_INT, @Self.Face[0][0]);
 glDisableClientState(GL_Vertex_Array);
 glDisableClientState(GL_TEXTURE_COORD_ARRAY);
 glDisableClientState(GL_NORMAL_ARRAY);  }
 glBegin(GL_Triangles);
 for i:=0 to num_Faces do
 begin
  for j:=0 to 2 do
   begin
    gltexcoord2fv(@TexV[Tex[i][j]]);
    glNormal3fv(@Face_Normal[i]);
    glvertex3fv(@Render_Vertex[Face[i][j]]);
   end;
 end;
 glEnd;
 if Self.Blend then begin glDepthMask(true);
end;
end;     
{$ENDREGION}
{$Region 'neighbour search'}
procedure TShadow_Mesh.Set_Near_Faces();{begin procedure - neighbour set}
Var
i,j, {for faces}
n,m:integer;{for 2 edges}
A1,A2,
B1,B2:integer;{A B edges points indexes}
begin
 Self.Anim(0);
 SetLength(Face_Normal,num_Faces+1);
 for i:=0 to num_Faces do
   begin
     Face_Normal[i]:=Get_Normal(Render_Vertex[Face[i][0]],
                Render_Vertex[Face[i][1]],
                Render_Vertex[Face[i][2]]);
   end;
 {neighbour search}
 SetLength(Self.Near_Face,num_Faces+1);
 for i:=0 to num_Faces do
  for j:=0 to 2 do
   begin
     Near_Face[i][j]:=-1;{Clear}
   end;
 for i:=0 to num_Faces do
  for j:=0 to num_Faces do
   if i<>j then
    for n:=0 to 2 do {edge 1}
    for m:=0 to 2 do {edge 2}
     if (Near_Face[i][n]=-1) then {if near face dont found}
     begin
      A1:=face[i][n];
      A2:=face[i][(n+1) mod 3];
      B1:=face[j][m];
      B2:=face[j][(m+1) mod 3];
      if ((A1=B1)and(A2=B2)) or ((A1=B2)and(A2=B1)) then
       begin
        Near_Face[i][n]:=j;
        Near_Face[j][m]:=i;
        break;
       end; 
     end;
 {plane array for shadow}
 SetLength(Self.Face_Plane,num_Faces+1);
 {plane array for shadowed boolean marker}
 SetLength(Self.illuminated,num_Faces+1);
end;
{$endRegion}
{$Region 'Lighting calculate'}
procedure TShadow_Mesh.Calculate_Face_Illumination();{procedure calculate - is the face is lightin?}
Var
  i,j:integer;
  a,b,c:TPoint;{Vertex of triangle for plane calculating}
  Side:Single;
  plane:TPlane;
begin
 for i:=0 to self.num_Faces do {opredeleniye ploskostey}
   begin
     a:=Render_Vertex[Face[i][0]];
     b:=Render_Vertex[Face[i][1]];
     c:=Render_Vertex[Face[i][2]];
     {plane (uravnenie ploskosti)}
  {ax + by + cz + d = 0 }
  {a}Face_Plane[i][0]:= a[1]*(b[2]-c[2]) + b[1]*(c[2]-a[2]) + c[1]*(a[2]-b[2]);
  {b}Face_Plane[i][1]:= a[2]*(b[0]-c[0]) + b[2]*(c[0]-a[0]) + c[2]*(a[0]-b[0]);
  {c}Face_Plane[i][2]:= a[0]*(b[1]-c[1]) + b[0]*(c[1]-a[1]) + c[0]*(a[1]-b[1]);
  {d}Face_Plane[i][3]:= -( a[0] * (b[1]*c[2] - c[1]*b[2]) +
                           b[0] * (c[1]*a[2] - a[1]*c[2]) +
                           c[0] * (a[1]*b[2] - b[1]*a[2]));
   end;
 for i:=0 to self.num_Faces do
   begin
     plane:=Face_Plane[i];
     side:={a} plane[0]*Light_Vector[0]+
           {b} plane[1]*Light_Vector[1]+
           {c} plane[2]*Light_Vector[2]+
           {d} plane[3];
     if side>=0 then
       Self.illuminated[i]:=true
      else
       Self.illuminated[i]:=false;
   end;
end;
{$endRegion}
{$REGION 'Find Volume'}
procedure TShadow_Mesh.Find_Volume();{create chadow volume geometry}
Var i,j:integer;
a,b,c,d:TPoint;{points of Volume}
procedure Add_To_Shadow(a,b,c,d:TPoint);
begin
 Shadow.num_Shadow_Vertex:=Shadow.num_Shadow_Vertex+1;
 SetLength(Shadow.SA,Shadow.num_Shadow_Vertex+1);{set array for shadow volume geometry}
 SetLength(Shadow.SB,Shadow.num_Shadow_Vertex+1);{set array for shadow volume geometry}
 SetLength(Shadow.SC,Shadow.num_Shadow_Vertex+1);{set array for shadow volume geometry}
 SetLength(Shadow.SD,Shadow.num_Shadow_Vertex+1);{set array for shadow volume geometry}
 Shadow.SA[Shadow.num_Shadow_Vertex]:=a;
 Shadow.SB[Shadow.num_Shadow_Vertex]:=b;
 Shadow.SC[Shadow.num_Shadow_Vertex]:=c;
 Shadow.SD[Shadow.num_Shadow_Vertex]:=d;
end;
begin
 Shadow.num_Shadow_Vertex:=1*4;
 SetLength(Shadow.SA,Shadow.num_Shadow_Vertex+1);{set array for shadow volume geometry}
 SetLength(Shadow.SB,Shadow.num_Shadow_Vertex+1);{set array for shadow volume geometry}
 SetLength(Shadow.SC,Shadow.num_Shadow_Vertex+1);{set array for shadow volume geometry}
 SetLength(Shadow.SD,Shadow.num_Shadow_Vertex+1);{set array for shadow volume geometry}
 Shadow.num_Shadow_Vertex:=0;
 for i:=0 to self.num_Faces do
   begin
     if illuminated[i] then
      for j:=0 to 2 do
       if (Near_face[i][j]=-1) or (not illuminated[Near_face[i][j]]) then
        begin
         a:=Render_Vertex[face[i][(j+1) mod 3]];
         b:=Render_Vertex[face[i][j]];
         c:=multi(plus(b,Light_Vector),Shadow_Length);
         d:=multi(plus(a,Light_Vector),Shadow_Length);
         add_To_Shadow(a,b,c,d);
        end;
   end;
end;         
{$ENDREGION}
{$REGION 'Draw_Volume'}
procedure TShadow_Mesh.Draw_Volume();{draw in stensil}
begin
{draw_shadow}
 Draw_Shadow_Volume(Self.Shadow);
end;       
{$ENDREGION}
{$REGION 'Get_Volume'}
function TShadow_Mesh.Get_Volume():TShadow;{get Volume Geometry}
begin
 Get_Volume.num_Shadow_Vertex:=Self.Shadow.num_Shadow_Vertex;
 Get_Volume.SA:=copy(Self.Shadow.SA);
 Get_Volume.SB:=copy(Self.Shadow.SB);
 Get_Volume.SC:=copy(Self.Shadow.SC);
 Get_Volume.SD:=copy(Self.Shadow.SD);
end;
{$ENDREGION}
{$REGION 'for Shadow Draw'}
procedure Draw_Shadow_Volume(var Shadow:TShadow);
Var i:integer;
begin
 glDisable( GL_BLEND );
 glEnable(GL_CULL_FACE);
 glCullFace(GL_Front);
 glDepthMask(false);
 glColor4f(1,1,1,1);
{--}
 glEnable(GL_STENCIL_TEST);
 glColorMask(false,false,false,false);
 //shadow tube
 glStencilFunc(GL_ALWAYS,1,1);
 glStencilOp(GL_KEEP,GL_KEEP,GL_Incr);
 glFrontFace(GL_CW);
 glBegin(gl_Quads);
 for i:=0 to Shadow.num_Shadow_Vertex do
   begin
    glVertex3fv(@Shadow.SA[i]);     
    glVertex3fv(@Shadow.SB[i]);
    glVertex3fv(@Shadow.SC[i]);
    glVertex3fv(@Shadow.SD[i]);
   end;
 glEnd;
 //back tube
 glStencilOp(GL_KEEP,GL_KEEP,GL_DECR);
 glFrontFace(GL_CCW);
 glBegin(gl_Quads);
 for i:=0 to Shadow.num_Shadow_Vertex do
   begin
    glVertex3fv(@Shadow.SA[i]);     
    glVertex3fv(@Shadow.SB[i]);
    glVertex3fv(@Shadow.SC[i]);
    glVertex3fv(@Shadow.SD[i]);
   end;
 glEnd;
 glFrontFace(GL_CW);
 glColorMask(true,true,true,true);
 glDepthMask(true);     
 glDisable(GL_STENCIL_TEST);
end;

procedure Render_Shadow_Mask();
begin
 glEnable(GL_STENCIL_TEST);
 glEnable(GL_Blend);
 glBlendFunc( GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA );
 glColor4f(0,0,0,0.5);
 glStencilFunc( GL_NOTEQUAL, 0, 7 );
 glStencilOp(GL_KEEP,GL_KEEP,GL_KEEP);
 glDisable(GL_Depth_Test);
 glPushMatrix();
 glLoadIdentity();
 glBegin(GL_QUADS);
  glVertex3f(-10,-10,0);
  glVertex3f( 10,-10,0);
  glVertex3f( 10, 10,0);
  glVertex3f(-10, 10,0);
 glend;        { }
 glPopMatrix();
 glEnable(GL_Depth_Test);
 GlDepthMask(true);
 glDisable(GL_Blend);
 glDisable(GL_STENCIL_TEST);
end;               
{$ENDREGION}

end.
