unit Use_Noise;

interface

const
 Max_Noise = 1024;
 a=317;
 c=1021;
{type
  TByte_Noise = record
    Start:byte;
    Value:byte;
  end;    }
  
function Simple_Noise(Num:integer):integer;
function Noise(A,B,C:integer):integer;overload;
function Noise(A,B:integer):integer;overload;
function Get_PN(X,Y,Z:integer;Scale:Single):integer;overload;  
function Get_PN(X,Y:integer;Scale:Single):integer;overload;

Var
W1:Single = 1.191;
W2:Single = 1.923;
W3:Single = 2.485;
W4:Single = 3.657;

implementation

function Simple_Noise(Num:integer):integer;
begin
 Simple_Noise:=(a*(Num)+c) mod (Max_Noise);
end;

function Noise(A,B,C:integer):integer;overload;
begin
 Noise:=  trunc((Simple_Noise(round(a*W1))+
          Simple_Noise(round(b*W2+a))+
          Simple_Noise(round(c*W3+b))+
          Simple_Noise(round(b*W3))+{}
          Simple_Noise(round(a*W4+c)))/5) mod Max_Noise;
end;

function Noise(A,B:integer):integer;overload;
begin
 Noise:=  trunc((Simple_Noise(round(a*W1))+
          Simple_Noise(round(b*W2+a))+
          Simple_Noise(round(b*W3))+{}
          Simple_Noise(round(a*W4+b)))/5) mod Max_Noise;
end;

function Get_PN(X,Y,Z:integer;Scale:Single):integer;overload;
Var a,b,c,d,n,m:integer;kx,ky,kz:Single;
begin
 X:=X+1024*256;
 Y:=Y+1024*256;
 Z:=Z+1024*256;
 kx:=(X)/Scale-(trunc((X)/Scale));
 ky:=(Y)/Scale-(trunc((Y)/Scale));
 kz:=(Z)/Scale-(trunc((Z)/Scale));
 {1-st plane}
 a:=Noise(trunc((X)/Scale)  ,trunc((Y)/Scale)  ,trunc((Z)/Scale));
 b:=Noise(trunc((X)/Scale)+1,trunc((Y)/Scale)  ,trunc((Z)/Scale));
 c:=Noise(trunc((X)/Scale)  ,trunc((Y)/Scale)+1,trunc((Z)/Scale));
 d:=Noise(trunc((X)/Scale)+1,trunc((Y)/Scale)+1,trunc((Z)/Scale));
 a:=trunc(kx*b+(1-kx)*a);
 b:=trunc(kx*d+(1-kx)*c);
 n:=trunc(ky*b+(1-ky)*a);
 {2-nd plane}
 a:=Noise(trunc((X)/Scale)  ,trunc((Y)/Scale)  ,trunc((Z)/Scale)+1);
 b:=Noise(trunc((X)/Scale)+1,trunc((Y)/Scale)  ,trunc((Z)/Scale)+1);
 c:=Noise(trunc((X)/Scale)  ,trunc((Y)/Scale)+1,trunc((Z)/Scale)+1);
 d:=Noise(trunc((X)/Scale)+1,trunc((Y)/Scale)+1,trunc((Z)/Scale)+1);
 a:=trunc(kx*b+(1-kx)*a);
 b:=trunc(kx*d+(1-kx)*c);
 m:=round(ky*b+(1-ky)*a); { }
 Get_PN:=(round((kz*m+(1-kz)*n)) mod Max_Noise);
// Get_PN:=a;
end;

function Get_PN(X,Y:integer;Scale:Single):integer;overload;
Var a,b,c,d:integer;kx,ky:Single;
begin
 X:=X+1024*256;
 Y:=Y+1024*256;
 kx:=(X)/Scale-(trunc((X)/Scale));
 ky:=(Y)/Scale-(trunc((Y)/Scale));
 {1-st plane}
 a:=Noise(trunc((X)/Scale)  ,trunc((Y)/Scale)  );
 b:=Noise(trunc((X)/Scale)+1,trunc((Y)/Scale)  );
 c:=Noise(trunc((X)/Scale)  ,trunc((Y)/Scale)+1);
 d:=Noise(trunc((X)/Scale)+1,trunc((Y)/Scale)+1);
 a:=trunc(kx*b+(1-kx)*a);
 b:=trunc(kx*d+(1-kx)*c);
 Get_PN:=(trunc(ky*b+(1-ky)*a) mod Max_Noise);
end;
                                  
end.
