unit Use_OpenGL;

interface

{use opengl
 0.03
 special functions for work with Open_GL
 -init
 -resolution
}

uses Windows, Messages, OpenGl;

function IntToStr(X:integer):string;
procedure InitGL(var ghRC:HGLRC;var ghDC:HDC;var Hand:THandle;W,H:Integer);
procedure On_Resize(Width,Height:integer);
procedure CloseGL(ghRC:HGLRC;ghDC:HDC;Hand:HWND);
procedure enable_bind_tex;
procedure disable_bind_tex;
procedure Change_Resolution(x, y: word);
procedure Restore_Resolution;

implementation

function IntToStr(X:integer):string;
begin
 Str(X, result);
end;

procedure Change_Resolution(x, y: word); { }
var
  dm: TDEVMODE;
begin
  ZeroMemory(@dm, sizeof(TDEVMODE));
  dm.dmSize := sizeof(TDEVMODE);
  dm.dmPelsWidth := x;
  dm.dmPelsHeight := y;
  dm.dmFields := DM_PELSWIDTH or DM_PELSHEIGHT;
  ChangeDisplaySettings(dm, 0);
end;

procedure Restore_Resolution;
begin
 ChangeDisplaySettings(devMode(nil^), 0);{ }
end;

procedure On_Resize(Width,Height:integer); {    }
begin
 glViewport(0,0,Width,Height);        
 glMatrixMode(GL_Projection);
 glLoadIdentity();
 gluPerspective(45.0, Width/Height, 0.1, 100.0);{  }
 glOrtho(-20,20,-20,20,0,50);
 gluLookAt(0,0,20, 0,0,0, 0,1,0);
 glMatrixMode(Gl_ModelView);
end;

function SetupPixelFormat(DC:HDC;g:byte):boolean;
var
pfd:PIXELFORMATDESCRIPTOR;
ppfd:PPIXELFORMATDESCRIPTOR;
pixelformat:integer;
begin
ppfd := @pfd;
ppfd.nSize := sizeof(PIXELFORMATDESCRIPTOR);
ppfd.nVersion := 1;
ppfd.dwFlags :=  PFD_DRAW_TO_WINDOW xor
                           PFD_SUPPORT_OPENGL xor
                           PFD_DOUBLEBUFFER;
ppfd.dwLayerMask := PFD_MAIN_PLANE;
ppfd.iPixelType := PFD_TYPE_RGBA;
ppfd.cColorBits := g;
ppfd.cDepthBits := g;
ppfd.cAccumBits := 0;
ppfd.cStencilBits := 8;
pixelformat := ChoosePixelFormat(dc, ppfd);
if pixelformat=0 then
begin
MessageBox(0, 'ChoosePixelFormat failed', 'Error', MB_OK);
SetupPixelFormat:=FALSE;
exit;
end;
if SetPixelFormat(dc, pixelformat, ppfd)=false then
begin
MessageBox(0, 'SetPixelFormat failed', 'Error', MB_OK);
SetupPixelFormat:=FALSE;
exit;
end;
SetupPixelFormat:=TRUE;
end;

procedure InitGL(var ghRC:HGLRC;var ghDC:HDC;var Hand:THandle;W,H:Integer);
Var
 p:TVector4f;
 d:TVector3f;
begin   {OpenGL}
 ghDC:=GetDC(HAND);       { }
 If SetupPixelFormat(ghDC,16)=False then
  Exit;
 ghRC:=wglCreateContext(ghDC);
 wglMakeCurrent(ghDC,ghRC);            {   }
 glClearColor(0.0,0.0,0.0,0.0);        {  - }
 On_Resize(W,H);                       {  }
 glEnable(GL_Color_Material);
 glEnable(GL_Depth_Test);              {Z }
 glEnable(GL_Lighting);                { }
 glEnable(GL_LIGHT0);                  { 0}
 glenable(GL_Point_Smooth);            { }
 p[0]:=2; p[1]:=-5; p[2]:=3; p[3]:=-2;      { }
 glLightFV(Gl_LIGHT0,Gl_Position,@p);          { }
 d[0]:=0.6; d[1]:=0.6; d[2]:=0.6;
 glLightFV(GL_LIGHT0,GL_AMBIENT,@d);
 {Settings}
 glDepthFunc(GL_LESS);		           //  Z 
 glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);   //
end;

procedure CloseGL(ghRC:HGLRC;ghDC:HDC;Hand:HWND);
begin
 If ghRC<>0 then             { ,  }
  begin
  wglMakeCurrent(ghDc,0);
  wglDeleteContext(ghRC);
 end;
 If ghDC<>0 then
  ReleaseDC(Hand,ghDC);
end;

procedure enable_bind_tex;
begin
 glEnable(GL_TEXTURE_2D);         { }
 glEnable(GL_BLEND);             { }
 glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);{ }
end;

procedure disable_bind_tex;
begin
 glDisable(GL_BLEND);      { }
 glDisable(GL_TEXTURE_2D); { }
end;

end.
