unit _World;

interface

Uses
 Use_Geometry,
 OpenGl,
 Use_Frustum,
 Use_3d,
 Use_Parts,
 Use_Noise,
 Use_Text;

const
  Max_enemies = 400;
  H_M_size = 100;
  Max_H_M = 30;
  Max_Bullets = 300;
  Max_Life = 10;
  Max_Fire =60;

type
  TGame_Type = (gt_none,gt_menu,gt_game);
  TEnemy_Type = (
      et_none,
      et_Tower,     {towers}
      et_Hand,       {electrostantion :)}
      et_Temple, {enemy temple/protal}
      et_Base, {your Base}
      et_flag,  {flags}
      et_Rocks  {rocks :) }
      );

  TBullet_Type = (
    bt_none,
    bt_flame,
    bt_fire,
    bt_bomb,
    bt_Dark,
    bt_Rock);

  TTerrain_H_Map = record
    H:Array [0..H_M_size+1,0..H_M_size+1] of single;
    N:Array [0..H_M_size,0..H_M_size] of TPoint;
    xb,yb:cardinal;{begin mh_size}
    zzz:byte;{poslednee obrashenie}
  end;

  TBullet = record
    tip:TBullet_Type;
    Point:TPoint;    
    Vector:TPoint;    
    Life:integer;
    Damage:integer;
  end;

  THero = record
    Speed:Single;
    Point:TPoint;
    Need_H:Single;
    Life:integer;
    Fire,Fire_Add,Fire_Reload:integer;
    Bombs:integer;
    {animation}
    Angle:TPoint;
    need_Angle:TPoint;
    Vector:TVect;
    planing:integer;{for planning animation}
    need_Vector:TVect; {need Vector}
    fase,Anim_Speed:byte;
    Anim:integer;
    Action,prev_action:byte;
    A_Koef,N_Koef:Single;
  end;

  TEnemy = record
    tip:TEnemy_type;
    Point:TPoint;
    Poz:TPozition;
    life:integer;
    side:byte;
    Reload:byte;
    anim:byte;
  end;

  TWorld = class
   private
    procedure Draw_Land;
    procedure Draw_Hero;   
    procedure Draw_Shadow;  
    Function Get_H(x,y:Cardinal):TPlane;
    function Get_Sector_H_Map(x,y:Cardinal):TTerrain_H_Map;
    procedure Find_Terrains;
    procedure Draw_Enemies;
    procedure Draw_Enemy_Shadows;
    procedure draw_Sky;
    procedure put_parts;
    procedure put_HUD;
    procedure Render_Menu;
   public
    Tex_Ground:Cardinal;
    Camera:TPozition;
    Hero:THero;
    Terrain:Array[0..Max_H_M] of TTerrain_H_Map;
    Enemy:array [0..Max_Enemies] of TEnemy;
    Bullet:array [0..Max_Bullets] of TBullet;
    Ter_kash:byte;
    Hero_Mesh:TShadow_Mesh;
    Tower_Mesh:TShadow_Mesh;
    Hand_Mesh:TShadow_Mesh;
    Temple_Mesh:TShadow_Mesh;
    Base_Mesh:TShadow_Mesh;
    {Rocks Meshes}
    Rock1_Mesh:TShadow_Mesh;
    Rock2_Mesh:TShadow_Mesh;
    Rock3_Mesh:TShadow_Mesh;
    {for random Rocks pozitions}
    Rock_Shadows:array[0..17] of TShadow;
    Rocks_Poz:array[0..17] of TPozition;
    Game_type:TGame_type;
    K:TPoint;{sdvig}
    Shadowed,
    Dragon_Shadowed,
    Terrain_full,
    Another_Objects:boolean;
    constructor Create();
    procedure Render;
    procedure Render_Scene;
    procedure Move_Objects;
    procedure Move_Hero(X,Y:smallint);
    procedure Animate_Hero;
    procedure add_Enemy(
     tip:TEnemy_type;
     Pt:TPoint;
     life:integer;
     side:byte);
    procedure add_Bullet(
     tip:TBullet_type;
     Pt,Vect:TPoint;
     Life:integer;
     Damage:integer
    );
  end;

Var AX,AY:Single;{for view}

implementation

{$REGION 'Create'}
constructor TWorld.Create();
Var i:byte;
begin
// Game_type:=gt_game;
 Game_type:=gt_menu;
 Hero.Point:=Point(0,0,0);
 for i:=0 to Max_H_M do
   begin
    Terrain[i].zzz:=255;
    Terrain[i].xb:=1000;//:=Get_Sector_H_Map((i mod 5)*H_M_size*10,(i div 5)*H_M_size*10);
   end;
 Dragon_Shadowed:=true;
 Another_Objects:=true;
 Terrain_full:=true;
 Shadowed:=true;
 Hero.Life:=Max_Life;
 Hero.Fire:=Max_Fire;
 Hero.Bombs:=20;
 Hero.Fire_Add:=0;
 Hero.Fire_Reload:=0;
end;
{$ENDREGION}

{$REGION 'Get_heigth functions'}
function TWorld.Get_Sector_H_Map(x,y:Cardinal):TTerrain_H_Map;
var i,j:byte;HM:TTerrain_H_Map;
begin
 if (x<Max_H_M) then exit;
 if (y<Max_H_M) then exit;
 for i:=0 to H_M_size+1 do
  for j:=0 to H_M_size+1 do
   begin
    HM.H[i,j]:=(Get_PN(x+i,y+j,10)/2+Get_PN(x+i,y+j,5)/4+Get_PN(x+i,y+j,2)/8)*0.01-3;
   end;
 for i:=0 to H_M_size do
  for j:=0 to H_M_size do
   begin
    HM.N[i,j]:=Get_Normal(
          Point(0,0,HM.H[i,j]*12),
          Point(1,0,HM.H[i+1,j]*12),
          Point(0,1,HM.H[i,j+1]*12));
   end;
 HM.xb:=x;
 HM.yb:=y;
 HM.zzz:=0;
 Get_Sector_H_Map:=HM;
end;

Function TWorld.Get_H(x,y:Cardinal):TPlane;
Var i,max:byte;bx,by:integer;flag:Boolean;
begin
 flag:=false;
 x:=x+1000;
 y:=y+1000;
 i:=Ter_kash;
 if (Self.Terrain[i].xb<=x) then
  if (Self.Terrain[i].xb+H_M_size>=x) then
   if (Self.Terrain[i].yb<=y) then
    if (Self.Terrain[i].yb+H_M_size>=y) then
  begin
   Get_H[3]:=Terrain[i].H[x-Terrain[i].xb,y-Terrain[i].yb];
   Get_H[0]:=Terrain[i].N[x-Terrain[i].xb,y-Terrain[i].yb][0];
   Get_H[1]:=Terrain[i].N[x-Terrain[i].xb,y-Terrain[i].yb][1];
   Get_H[2]:=Terrain[i].N[x-Terrain[i].xb,y-Terrain[i].yb][2];
   Terrain[i].zzz:=0;
   Ter_kash:=i;
   flag:=true;
   exit;
  end;
 for i:=0 to Max_H_M do  //find heigth in our terrains
 begin
  if (Self.Terrain[i].xb<=x) then
  if (Self.Terrain[i].xb+H_M_size>=x) then
  if (Self.Terrain[i].yb<=y) then
  if (Self.Terrain[i].yb+H_M_size>=y) then
  begin
   Get_H[3]:=Terrain[i].H[x-Terrain[i].xb,y-Terrain[i].yb];
   Get_H[0]:=Terrain[i].N[x-Terrain[i].xb,y-Terrain[i].yb][0];
   Get_H[1]:=Terrain[i].N[x-Terrain[i].xb,y-Terrain[i].yb][1];
   Get_H[2]:=Terrain[i].N[x-Terrain[i].xb,y-Terrain[i].yb][2];
   Terrain[i].zzz:=0;
   Ter_kash:=i;
   flag:=true;
   break;
  end;
 end;
 if not flag then //if not found - generate
 begin
  max:=0;
  for i:=1 to Max_H_M do  //find oldest array
   if (Terrain[max].zzz<=Terrain[i].zzz) then
    max:=i;
  bx:=trunc(x/H_M_size)*H_M_size;
  by:=trunc(y/H_M_size)*H_M_size;
  Terrain[max]:=Get_Sector_H_Map(bx,by);
  Get_H[3]:=Terrain[max].H[x-Terrain[max].xb,y-Terrain[max].yb];
  Get_H[0]:=Terrain[max].N[x-Terrain[max].xb,y-Terrain[max].yb][0];
  Get_H[1]:=Terrain[max].N[x-Terrain[max].xb,y-Terrain[max].yb][1];
  Get_H[2]:=Terrain[max].N[x-Terrain[max].xb,y-Terrain[max].yb][2];
 end;
end;

procedure TWorld.Find_Terrains;
Var i:byte;
begin
 for i:=0 to Max_H_M do
  if (Terrain[i].zzz<255) then Terrain[i].zzz:=Terrain[i].zzz+1;
end;
{$ENDREGION}

{$REGION 'Move hero'}
procedure TWorld.Move_Hero(X,Y:smallint);
begin
 if X>0 then    //forward
  begin    
   if Y>0 then   //rigth
    begin
     //Hero.need_Angle[2]:=-12;
     Hero.need_Angle[1]:=15;
     Hero.Action:=3;
     Hero.need_Vector[1]:=0.05;
    end else
   if Y<0 then   //left
    begin
     //Hero.need_Angle[2]:=12;
     Hero.need_Angle[1]:=-15;
     Hero.Action:=2;
     Hero.need_Vector[1]:=-0.05;
    end else      //center
    begin
     Hero.need_Vector[1]:=0;
     Hero.Action:=0;
     Hero.need_Vector[0]:=-0.08;
     Hero.need_Angle[1]:=0;
    end;
   Hero.need_Angle[2]:=0;
   Hero.need_Vector[0]:=0.4;
   Hero.Action:=1;
   Hero.N_Koef:=0;
   Hero.need_Angle[0]:=0;
   Hero.Anim_Speed:=16;
  end else
 if X<0 then    //backWard
  begin
   if Y>0 then   //rigth
    begin
     Hero.need_Angle[0]:=-26;
     Hero.need_Angle[2]:=-26;
     Hero.Action:=3;
     Hero.need_Vector[1]:=0.06;
     Hero.need_Vector[0]:=-0.06;
    end else
   if Y<0 then   //left
    begin
     Hero.need_Angle[0]:=-26;
     Hero.need_Angle[2]:=26;
     Hero.need_Vector[1]:=-0.06;
     Hero.need_Vector[0]:=-0.06;
     Hero.Action:=2;
    end else      //center
    begin
     Hero.need_Angle[0]:=-30;
     Hero.need_Angle[2]:=0;
     Hero.need_Vector[1]:=0;
     Hero.Action:=0;
     Hero.need_Vector[0]:=-0.08;
    end;
   Hero.Anim_Speed:=18;
   Hero.Action:=4;
   Hero.N_Koef:=1;
   Hero.planing:=-250;
   Hero.need_Angle[1]:=0;
  end else      //on place
  begin
   if Y>0 then   //rigth
    begin
     Hero.need_Angle[2]:=-30;
     Hero.Action:=3;
     Hero.need_Vector[1]:=0.08;
     Hero.Anim_Speed:=18;
    end else
   if Y<0 then   //left
    begin
     Hero.need_Angle[2]:=30;
     Hero.need_Vector[1]:=-0.08;
     Hero.Action:=2;
     Hero.Anim_Speed:=18;
    end else      //center
    begin
     Hero.need_Angle[2]:=0;
     Hero.need_Vector[1]:=0;
     Hero.Action:=0;
     Hero.Anim_Speed:=16;
    end;
   Hero.need_Vector[0]:=0;
   Hero.Action:=0;
   Hero.N_Koef:=1;
   Hero.need_Angle[0]:=0;
   Hero.planing:=-250;
   Hero.need_Angle[1]:=0;
  end;
 Hero.Point[0]:=Hero.Point[0]+Get_X_V(-AY,Hero.Vector[1])+Get_Y_V(AY,Hero.Vector[0]);
 Hero.Point[1]:=Hero.Point[1]+Get_Y_V(-AY,Hero.Vector[1])+Get_X_V(AY,Hero.Vector[0]);
 K[0]:=-Hero.Point[0];
 K[2]:=-Hero.Point[1];
end;
{$ENDREGION}

{$REGION 'Sky'}
procedure TWorld.draw_Sky;
Var color:Single;
begin
 glPushMatrix();
 glLoadIdentity();
 glDisable(GL_Texture_2d);
 {06 25 7f}
 glBegin(GL_Quads);
 glNormal3f(0,0,-1);
 color:=(AX-40-100)/90*5;
 glColor3f(color*0.05,color*0.2,color*0.6);
 glVertex3f(-50,-20,100);
 glVertex3f( 50,-20,100);
 color:=(AX+40-100)/90*5;
 glColor3f(color*0.05,color*0.2,color*0.6);
 glVertex3f( 50, 50,100);
 glVertex3f(-50, 50,100);
 glEnd;
 glEnable(GL_Texture_2d);
 glPopMatrix();
end;
{$ENDREGION}

{$REGION 'Move_Objects'}
procedure TWorld.Move_Objects;
Var i,j,z:integer;
begin
 //Hero
 if Hero.Fire_Reload>0 then 
  Hero.Fire_Reload:=Hero.Fire_Reload-1;
 if (Hero.Fire<Max_Fire) then
  if (Hero.Fire_Add=0) then
  begin
   Hero.Fire_Add:=17;
   Hero.Fire:=Hero.Fire+1;  
  end;
 if Hero.Fire_Add>0 then
  Hero.Fire_Add:=Hero.Fire_Add-1;
 if Hero.Life<0 then
  begin
   Hero.Life:= Hero.Life-10;
   for i:=0 to 20 do
      Add_Particle(Point(-Hero.Point[0],-Hero.Point[2],-Hero.Point[1]),
        Point(Random(100)/1000-0.05,Random(100)/1000-0.05,Random(100)/1000-0.05)
        ,2,5+Random(15));{{dragon flame}
  end;
 if hero.Life<-1000 then
   begin
    Hero.Life:=Max_Life;
    Hero.Point:=Point(-1000,-1000,20);
   end;
 if hero.Life<Max_Life then
  if (-Hero.Point[0]+2>1000) then
  if (-Hero.Point[0]-2<1000) then
  if (-Hero.Point[1]+2>1000) then
  if (-Hero.Point[1]-2<1000) then
   begin
    Hero.Life:=Hero.Life+1;
    if (Hero.Fire<Max_Fire) then Hero.Fire:=Hero.Fire+1;
   end;
 {bullets}
 for i:=0 to Max_Bullets do
  if (Bullet[i].Life>0) then
   begin
    Bullet[i].Life:=Bullet[i].Life-1;
    Bullet[i].Point:=plus(Bullet[i].Point,Bullet[i].Vector);
    case Bullet[i].tip of
     bt_none:;
     bt_flame:Add_Particle(Bullet[i].Point,
      Point(Random(10)/1000-0.005,Random(10)/1000-0.005,Random(10)/1000-0.005)
      ,0,20);{dragon flame}
     bt_fire:begin
      Add_Particle(Bullet[i].Point,
        Point(Random(20)/1000-0.01,Random(20)/1000-0.01,Random(20)/1000-0.01)
        ,0,5+Random(15));{{dragon flame}
      if Random(3)=0 then      
      Add_Particle(Bullet[i].Point,
        Point(Random(20)/1000-0.01,Random(20)/1000-0.01,Random(20)/1000-0.01)
        ,3,10);{dragon flame}
     end;
     bt_dark:   {tower fire}
      begin
       Add_Particle(Bullet[i].Point,
         Point(Random(20)/1000-0.01,Random(20)/1000-0.01,Random(20)/1000-0.01)
         ,5,5+Random(15));{chaos}
       {  if Random(2)=0 then
         Add_Particle(Bullet[i].Point,
           Bullet[i].Vector,
           3,15);   }
      end;
     bt_bomb:;{dragon bomb}
     bt_Rock:;
    end;
    if (Bullet[i].Point[1]>Get_H(trunc(Bullet[i].Point[0]),trunc(Bullet[i].Point[2]))[3]) then
     begin
      Bullet[i].Life:=0;
      for j:=0 to 10 do        
       Add_Particle(Bullet[i].Point,
        Point(Random(10)/1000-0.005,Random(10)/1000-0.005,Random(00)/1000-0.005)
        ,3,20);{dragon flame}
     end;
    {hero collision}
    if (Bullet[i].tip=bt_dark) then
     if (-Hero.Point[0]+0.4>Bullet[i].Point[0]) then
     if (-Hero.Point[0]-0.4<Bullet[i].Point[0]) then
     if (-Hero.Point[1]+0.4>Bullet[i].Point[2]) then
     if (-Hero.Point[1]-0.4<Bullet[i].Point[2]) then
      begin
       Hero.Life:=Hero.Life-1;
       Bullet[i].Life:=0; 
      end;
    {enemy collision}
    if (Bullet[i].tip<>bt_dark) then    
    for j:=0 to Max_Enemies do
     case Enemy[j].tip of
      et_none:;
      et_Tower:
        begin
         if (Enemy[j].Life>0) then
         if (Enemy[j].Point[0]+0.4>Bullet[i].Point[0]) then
         if (Enemy[j].Point[0]-0.4<Bullet[i].Point[0]) then
         if (Enemy[j].Point[2]+0.4>Bullet[i].Point[2]) then
         if (Enemy[j].Point[2]-0.4<Bullet[i].Point[2]) then
          begin
            Bullet[i].Life:=0;
            Enemy[j].life:=Enemy[j].life-10;
          end;
        end;
      et_Hand:
        begin
         if (Enemy[j].Life>0) then
         if (Enemy[j].Point[0]+0.3>Bullet[i].Point[0]) then
         if (Enemy[j].Point[0]-0.3<Bullet[i].Point[0]) then
         if (Enemy[j].Point[2]+0.3>Bullet[i].Point[2]) then
         if (Enemy[j].Point[2]-0.3<Bullet[i].Point[2]) then
          begin
            Bullet[i].Life:=0;
            Enemy[j].life:=Enemy[j].life-10;
          end;
        end;
      et_Temple:
        begin
         if (Enemy[j].Life>0) then
         if (Enemy[j].Point[0]+0.5>Bullet[i].Point[0]) then
         if (Enemy[j].Point[0]-0.5<Bullet[i].Point[0]) then
         if (Enemy[j].Point[2]+0.5>Bullet[i].Point[2]) then
         if (Enemy[j].Point[2]-0.5<Bullet[i].Point[2]) then
          begin
            Bullet[i].Life:=0;
            Enemy[j].life:=Enemy[j].life-10;
         {   for z := 0 to 50 do
             Add_Particle(Bullet[i].Point,
              Point(Random(20)/1000-0.01,Random(20)/1000-0.01,Random(20)/1000-0.01)
              ,2,80);}
          end;
        end;
      et_Rocks:;
     end;
   end;
 {tower fire}
 j:=20;
 z:=0;
 for i:=0 to Max_Enemies do
   if Enemy[i].tip=et_Tower then
   begin
       if (Enemy[i].life<=0) then //tower die
        begin
         Enemy[i].life:=Enemy[i].life-10;
         if (Enemy[i].life<-2000) then Enemy[i].tip:=et_none;
         Enemy[i].Point[1]:=Enemy[i].Point[1]+0.02;
         for j := 0 to 20 do
          Add_Particle(plus(Enemy[i].Point,Point(0,-Random(10)/10,0)),
           Point(Random(20)/1000-0.01,Random(20)/1000-0.01,Random(20)/1000-0.01)
           ,3,40);
        end;
    if (Enemy[i].Reload=0) then
    begin
     if (Enemy[i].Point[0]+j>-Hero.Point[0]) then
     if (Enemy[i].Point[0]-j<-Hero.Point[0]) then
     if (Enemy[i].Point[2]+j>-Hero.Point[1]) then
     if (Enemy[i].Point[2]-j<-Hero.Point[1]) then
     begin
      add_Bullet(bt_dark,
       Point(Enemy[i].Point[0],Enemy[i].Point[1]-2,Enemy[i].Point[2]),
       {plus(}Point(Get_X_V(Get_A(Enemy[i].Point[0],Enemy[i].Point[2],-Hero.Point[0],-Hero.Point[1])
         ,0.2),
       0,
       Get_Y_V(Get_A(Enemy[i].Point[0],Enemy[i].Point[2],-Hero.Point[0],-Hero.Point[1])
         ,0.2)),
       {Point(Random(20)/1000-0.01,Random(20)/1000-0.01,Random(20)/1000-0.01)), }
       100,150);
      Enemy[i].Reload:=60+Random(10);
     end;
    end else
    if (Enemy[i].Reload>0) then
     Enemy[i].Reload:=Enemy[i].Reload-1;
   end else
   if Enemy[i].tip=et_Hand then
    begin
     z:=z+1;
       if (Enemy[i].life<=0) then //tower die
        begin
         Enemy[i].life:=Enemy[i].life-10;
         if (Enemy[i].life<-2000) then Enemy[i].tip:=et_none;
         Enemy[i].Point[1]:=Enemy[i].Point[1]+0.005;
         for j := 0 to 20 do
          Add_Particle(plus(Enemy[i].Point,Point(0,-Random(10)/15,0)),
           Point(Random(20)/1000-0.01,Random(20)/1000-0.01,Random(20)/1000-0.01)
           ,3,40);
        end;
    end else
     if Enemy[i].tip=et_Temple then
      begin  
       z:=z+1;
       if (Enemy[i].life<=0) then //tower die
        begin
         Enemy[i].life:=Enemy[i].life-10;
         if (Enemy[i].life<-2000) then Enemy[i].tip:=et_none;
         Enemy[i].Point[1]:=Enemy[i].Point[1]+0.005;
         for j := 0 to 20 do
          Add_Particle(plus(Enemy[i].Point,Point(0,-Random(10)/20,0)),
           Point(Random(40)/1000-0.02,Random(40)/1000-0.02,Random(40)/1000-0.02)
           ,3,40);
        end;
      end;
 {}
 Move_Parts;
 if z=0 then
  begin
   Game_type:=gt_menu;
   Menu.Visible_Group:=3;
   Enemy[0].tip:=et_Temple;
  end;
// if (random(5)=0) then
 // Add_Particle(0,0,0,Random(10)/1000-0.005,-0.03-Random(10)/1000,Random(10)/1000-0.005,0,40); //test
end;
{$ENDREGION}

{$REGION 'Animate hero'}
procedure TWorld.Animate_Hero;
begin
// Hero.Angle[1]:=AY;
 {speed find}
 if (abs(Hero.Vector[0]-Hero.need_Vector[0])>0.001) then
 begin
  if (Hero.Vector[0]<Hero.need_Vector[0]) then
  begin
   Hero.Vector[0]:=Hero.Vector[0]+0.004;
  end else
  if (Hero.Vector[0]>Hero.need_Vector[0]) then
  begin
   Hero.Vector[0]:=Hero.Vector[0]-0.004;
  end;
 end;
 {speed Y find}
 if (abs(Hero.Vector[1]-Hero.need_Vector[1])>0.001) then
 begin
  if (Hero.Vector[1]<Hero.need_Vector[1]) then
  begin
   Hero.Vector[1]:=Hero.Vector[1]+0.004;
  end else
  if (Hero.Vector[1]>Hero.need_Vector[1]) then
  begin
   Hero.Vector[1]:=Hero.Vector[1]-0.004;
  end;
 end;
 {animation koef find}
 if (abs(Hero.N_Koef-Hero.A_Koef)>0.01) then
 if (Hero.N_Koef>Hero.A_Koef) then
  begin
   Hero.A_Koef:=Hero.A_Koef+0.02;
  end else
  begin
   Hero.A_Koef:=Hero.A_Koef-0.02;
  end;
 {animation X angle}
 if (abs(Hero.Angle[0]-Hero.need_Angle[0])>0.11) then
 if (Hero.Angle[0]>Hero.need_Angle[0]) then
  begin
   Hero.Angle[0]:=Hero.Angle[0]-0.5;
  end else
  begin
   Hero.Angle[0]:=Hero.Angle[0]+1;
  end;
 {animation Z angle}
 if (abs(Hero.Angle[2]-Hero.need_Angle[2])>0.11) then
 if (Hero.Angle[2]>Hero.need_Angle[2]) then
  begin
   Hero.Angle[2]:=Hero.Angle[2]-2;
  end else
  begin
   Hero.Angle[2]:=Hero.Angle[2]+2;
  end;
 {animation Y angle - rotation}
 if (abs(Hero.Angle[1]-Hero.need_Angle[1])>0.11) then
 if (Hero.Angle[1]>Hero.need_Angle[1]) then
  begin
   Hero.Angle[1]:=Hero.Angle[1]-1;
  end else
  begin
   Hero.Angle[1]:=Hero.Angle[1]+1;
  end;
 {planning}
 if (Hero.planing<0) and (Hero.Action=1) then
  Hero.planing:=Hero.planing+1;
 if (Hero.planing=0) and (Hero.Anim>560) and (Hero.Anim<600) then
 begin
  Hero.planing:=100;
 end;
 if (Hero.planing>0) then
 begin
  Hero.planing:=Hero.planing-1;
  if (Hero.planing=0) then hero.planing:=-250;  
 end else 
 {animate}
  Hero.Anim:=Hero.Anim+Hero.Anim_Speed;
 { Action
 0-stop
 1-fly forward
 2-fly left
 3-fly rigth
 4-fly backward}
{ case Hero.Action of
  0:begin
     Hero.Angle[2]:=Hero.Angle[2]*0.8;
    end;
 end;  }
// Hero.Action:=Hero.Action+1;
// if Hero.Action>200 then Hero.Action:=0;
 if Hero.Anim>=900 then Hero.Anim:=100;
end;
{$ENDREGION}

{$REGION 'Render_terrain'}
procedure TWorld.Draw_Land;
Var
 i,j,sz:integer;
 n,m,x,y:integer;
 S:TPoint;
 H:Single;
 D1,D2,D3:byte;{detail levels size x1,x2,x4}
 function Get_Heigth(sz:byte;n,m,x,y:integer):TPlane;
 Var H:Single;
 begin
  Get_Heigth[0]:=Get_H(n+x,m+y)[0];
  Get_Heigth[1]:=Get_H(n+x,m+y)[1];
  Get_Heigth[2]:=Get_H(n+x,m+y)[2];
  Get_Heigth[3]:=Get_H(n+x,m+y)[3];
  if (sz=1) then
    begin
     if (n=-D1*2) or (n=D1*2+2) then
      if (abs(m) = trunc(abs(m)/2)*2+1) then
       Get_Heigth[3]:=(Get_H(n+x,m+y-1)[3]+Get_H(n+x,m+y+1)[3])/2;
     if (m=-D1*2) or (m=D1*2+2) then
      if (abs(n) = trunc(abs(n)/2)*2+1) then
       Get_Heigth[3]:=(Get_H(n+x-1,m+y)[3]+Get_H(n+x+1,m+y)[3])/2;
    end;
  if (sz=2) then
    begin
     if (n=-D2*4) or (n=D2*4+4) then
      if (abs(m) = trunc(abs(m)/4)*4+2) then
       Get_Heigth[3]:=(Get_H(n+x,m+y-2)[3]+Get_H(n+x,m+y+2)[3])/2;
     if (m=-D2*4) or (m=D2*4+4) then
      if (abs(n) = trunc(abs(n)/4)*4+2) then
       Get_Heigth[3]:=(Get_H(n+x-2,m+y)[3]+Get_H(n+x+2,m+y)[3])/2;
    end;
 end;
 procedure Put_Ground_Tile(sz:byte;n,m,x,y:integer);{s-sdvig}
 Var H:TPlane;
 begin
  H:=Get_Heigth(sz,n+sz,m   ,x,y); glNormal3f(H[0],H[1],H[2]);
  glTexCoord2f(x+sz,y   );  glvertex3f(S[0]+n+sz,S[1]+H[3],S[2]+m);
  H:=Get_Heigth(sz,n   ,m   ,x,y); glNormal3f(H[0],H[1],H[2]);
  glTexCoord2f(x   ,y   );  glvertex3f(S[0]+n   ,S[1]+H[3],S[2]+m);
  H:=Get_Heigth(sz,n   ,m+sz,x,y); glNormal3f(H[0],H[1],H[2]);
  glTexCoord2f(x   ,y+sz);  glvertex3f(S[0]+n   ,S[1]+H[3],S[2]+m+sz);
  H:=Get_Heigth(sz,n+sz,m+sz,x,y); glNormal3f(H[0],H[1],H[2]);
  glTexCoord2f(x+sz,y+sz);  glvertex3f(S[0]+n+sz,S[1]+H[3],S[2]+m+sz);
 end;
 procedure put_Ground2(n,m,x,y:integer);
 begin       
  if (abs(n)>D1*2) or (abs(m)>D1*2) then
  begin
    Put_Ground_Tile(2,n,m,x,y);
  end else
  begin
    Put_Ground_Tile(1,n  ,m  ,x,y);
    Put_Ground_Tile(1,n+1,m  ,x,y);
    Put_Ground_Tile(1,n+1,m+1,x,y);
    Put_Ground_Tile(1,n  ,m+1,x,y);
  end;
 end;
 procedure put_Ground4(n,m,x,y:integer);
 begin
  if Sphere_in_Frustum(S[0]+n+2,S[1]/2+2,S[2]+m+2,3) then
  if (abs(n)>D2*4) or (abs(m)>D2*4) then
  begin
    Put_Ground_Tile(4,n,m,x,y);
  end else
  begin
    Put_Ground2(n  ,m  ,x,y);
    Put_Ground2(n+2,m  ,x,y);
    Put_Ground2(n+2,m+2,x,y);
    Put_Ground2(n  ,m+2,x,y);
  end;
 end;
begin
{}
 Find_Terrains;
 Find_Frustum;
 if Terrain_full then
 begin
  D1:=10;
  D2:=15;
  D3:=25; {terrain detail levels size}
 end else
 begin
  D1:=5;
  D2:=10;
  D3:=20;
 end;
{ D1:=4;
 D2:=8;
 D3:=12;  }
 {calculating of sdvig}
 x:=trunc(K[0]/4)*4;
 y:=trunc(K[2]/4)*4;
 S[0]:=trunc(K[0]/4)*4-K[0];
 S[2]:=trunc(K[2]/4)*4-K[2];
 Hero.Need_H:=-Get_Heigth(4,0,0,trunc(K[0]),trunc(K[2]))[3]+2.6;
 {need dragon Heigth}
 Hero.Point[2]:=Hero.Point[2]*0.95+Hero.Need_H*0.05;
 K[1]:=-Hero.Point[2];
 S[1]:=-K[1];
 {render}
 glPushMatrix();
 //glTranslatef(0,Hero.Point[2]*2,0); {Heigth!}
 glEnable(GL_Texture_2d);
 glBindTexture(GL_Texture_2d,self.Tex_Ground);
// glColor4f(2,1,0.2,5);
// glColor4f(0.4,0.4,1.5,5);
// glColor4f(1.5,1.4,0.4,5);//a7a34a
 glColor4f(1,1,1,5);
 glbegin(GL_Quads);
 for i:=-D3 to D3 do
  for j:=-D3 to D3 do
  begin
    n:=i*4;
    m:=j*4;
    Put_Ground4(n,m,x,y);
  end;
 glend;
 glPopMatrix();
end;
{$ENDREGION}

{$REGION 'Draw Hero'}
procedure TWorld.Draw_Hero;
Var Rt:TMatrix;Cl:Single;
begin
 glPushMatrix();
 if Hero.Life<0 then
  Cl:=(1000+Hero.Life)/1000 else
  Cl:=1;
 glColor4f(Cl,Cl,Cl,5);
 Hero_Mesh.Anim(Hero.Anim/100,Hero.Anim/100+10,Hero.A_Koef);
 Rt:=Default_TMatrix;
 Rt:=multi(Rt,Rotate(Hero.Angle[1]+AY,0,1,0));{turn on axe}
 Rt:=multi(Rt,Rotate(Hero.Angle[0],1,0,0));{turn on axe}
 Rt:=multi(Rt,Rotate(Hero.Angle[2],0,0,1));{turn on axe}
 Hero_Mesh.Rotate(Rt);
 Hero_Mesh.Render(Hero_Mesh.Texture);
 if Self.Dragon_Shadowed then
 begin
  Hero_Mesh.Calculate_Face_Illumination;
  Hero_Mesh.Find_Volume;
 end;                 
 glColor4f(1,1,1,1);
 glPopMatrix();
end;

procedure TWorld.Draw_Shadow;
begin
// glColor4f(5,5,5,5);
 Hero_Mesh.Draw_Volume;
end;
{$ENDREGION}

{$REGION 'Draw_Enemies'}
procedure TWorld.Draw_Enemies;
Var i,j:integer;
begin
 glPushMatrix();
 glTranslatef(-K[0],-K[1],-K[2]);  
 Find_Frustum;
 for i:=0 to Max_enemies do
  if (Enemy[i].tip>et_none) then
  if Sphere_in_Frustum(Enemy[i].Point,2) then
  begin
   glPushMatrix();
   case Enemy[i].tip of
    et_none:;
    et_tower:
      Begin
       glTranslatef(Enemy[i].Point[0],Enemy[i].Point[1],Enemy[i].Point[2]);
       Tower_Mesh.Render(Tower_Mesh.Texture);
       Enemy[i].anim:=Enemy[i].anim+3;
       Add_Particle(Enemy[i].Point[0],Enemy[i].Point[1]-1.8+abs(Enemy[i].anim-128)/2024,Enemy[i].Point[2]
         ,0,0,0,1,1);
      end;
    et_hand:
      Begin   
       glTranslatef(Enemy[i].Point[0],Enemy[i].Point[1],Enemy[i].Point[2]);
       Hand_Mesh.Render(Tower_Mesh.Texture);
       Add_Particle(Enemy[i].Point[0],Enemy[i].Point[1]-1.15,Enemy[i].Point[2]
         ,0,0,0,2,1);
      end;
    et_Temple:
      Begin
       glTranslatef(Enemy[i].Point[0],Enemy[i].Point[1],Enemy[i].Point[2]);
       Temple_Mesh.Render(Tower_Mesh.Texture);
      end;
    et_Base:
      Begin
       glTranslatef(Enemy[i].Point[0],Enemy[i].Point[1],Enemy[i].Point[2]);
       Base_Mesh.Render(Rock1_Mesh.Texture);
      end;
    et_Rocks:
      if Self.Another_Objects then
      Begin
       glTranslatef(Enemy[i].Point[0],Enemy[i].Point[1],Enemy[i].Point[2]);
       case Enemy[i].side of
        0..5:begin
           glmultMatrixf(@Rocks_Poz[Enemy[i].side]);
           Rock1_Mesh.Render(Rock1_Mesh.Texture);
          end;
        6..11:begin
           glmultMatrixf(@Rocks_Poz[Enemy[i].side]);
           Rock2_Mesh.Render(Rock1_Mesh.Texture);
          end;
        12..17:begin
           glmultMatrixf(@Rocks_Poz[Enemy[i].side]);
           Rock3_Mesh.Render(Rock1_Mesh.Texture);
          end;
       end;
      end;
   end;
   glPopMatrix();
  end;
 glPopMatrix();
end;

procedure TWorld.Draw_Enemy_Shadows;
Var i:integer;
begin
 glPushMatrix();
 glTranslatef(-K[0],-K[1],-K[2]);
 for i:=0 to Max_enemies do
  if (Enemy[i].tip>et_none) then
  if Sphere_in_Frustum(Enemy[i].Point,2.5) then
  begin
   glPushMatrix();
   case Enemy[i].tip of
    et_none:;
    et_tower:
    // if Sphere_in_Frustum(Enemy[i].Point,2) then
      Begin
       glTranslatef(Enemy[i].Point[0],Enemy[i].Point[1],Enemy[i].Point[2]);
       Tower_Mesh.Draw_Volume;
      end;
    et_hand:
      Begin
       glTranslatef(Enemy[i].Point[0],Enemy[i].Point[1],Enemy[i].Point[2]);
       Hand_Mesh.Draw_Volume;
      end;   
    et_Temple:
      Begin
       glTranslatef(Enemy[i].Point[0],Enemy[i].Point[1],Enemy[i].Point[2]);
       Temple_Mesh.Draw_Volume;
      end;
    et_Rocks:   
      if Self.Another_Objects then
      Begin
       glTranslatef(Enemy[i].Point[0],Enemy[i].Point[1],Enemy[i].Point[2]);
       Draw_Shadow_Volume(Rock_Shadows[Enemy[i].side]);{ }
      end;
    et_Base:
      begin
       glTranslatef(Enemy[i].Point[0],Enemy[i].Point[1],Enemy[i].Point[2]);
       Base_Mesh.Draw_Volume;
      end;
   end;
   glPopMatrix();
  end;
 glPopMatrix();
end;
{$ENDREGION}

{$REGION 'add Enemies'}
procedure TWorld.add_Enemy(tip: TEnemy_Type; Pt: TVector3f; life: Integer;side:byte);
Var i:integer;
begin
 for i := 0 to Max_Enemies do
  if (Enemy[i].tip=ET_none) then
   begin
    Enemy[i].tip:=tip;
    Enemy[i].Point:=Pt;
    Enemy[i].Point[1]:=Get_H(trunc(abs(Enemy[i].Point[0])),trunc(abs(Enemy[i].Point[2])))[3];
    Enemy[i].life:=Life;
    Enemy[i].Poz:=Default_TPozition;
    Enemy[i].side:=side;
    Enemy[i].anim:=0;
    break;
   end;
end;
{$ENDREGION}

{$REGION 'put_parts'}
procedure TWorld.put_parts;
Var i:byte;
begin
 Use_Parts.k[0]:=-Self.K[0];
 Use_Parts.k[1]:=-Self.K[1];
 Use_Parts.k[2]:=-Self.K[2];
 Pt[0]:=Point(-1,0,0);
 Pt[1]:=Point(0,-1,0);
 Pt[2]:=Point(1,0,0);
 Pt[3]:=Point(0,1,0);
 glPushMatrix();
 for i:=0 to 3 do
  begin
   Pt[i]:=Multi(Rotate(-AX,1,0,0),Pt[i]);
   Pt[i]:=Multi(Rotate(AY,0,1,0),Pt[i]);
  end;
 Render_Parts;
 glPopMatrix();
end;
{$ENDREGION}

{$REGION 'HUD'}
procedure TWorld.put_HUD;
Var i,j:integer;X,Y:Single; a,b:byte;
begin
 glLoadIdentity();
 glBindTexture(GL_Texture_2d,Parts_Tex);
 glDisable(GL_Depth_Test);
 glDepthMask(false);
 glDisable(GL_texture_2d);
 {minimap}                 
 X:=1.8;
 Y:=-1.3;
 glTranslatef(X,Y,0);
 glRotatef(AY,0,0,-1);
 glBegin(GL_Points);
 glNormal3f(0,1,0);
 glColor3f(0.5,0.5,5);
 glVertex2f(0,0);
 for i:=0 to Max_Enemies do
  begin
   case Enemy[i].tip of
     et_Tower:begin
      glColor3f(5,0,0);
      glVertex2f((Enemy[i].Point[0]+Hero.Point[0])/200,-(Enemy[i].Point[2]+Hero.Point[1])/200);
     end;
     et_Base:begin
      glColor3f(0,5,0);
      glVertex2f((Enemy[i].Point[0]+Hero.Point[0])/200,-(Enemy[i].Point[2]+Hero.Point[1])/200);
     end;
     et_Temple,et_Hand:begin
      glColor3f(0,0,5);
      glVertex2f((Enemy[i].Point[0]+Hero.Point[0])/200,-(Enemy[i].Point[2]+Hero.Point[1])/200);
     end;
   end;
  end;
 glEnd;
 glRotatef(AY,0,0,1);
 glTranslatef(-X,-Y,0);
 glEnable(GL_blend);
 glEnable(GL_texture_2d);
 {fire}
 glColor3f(5,5,5);
 X:=-2;
 Y:=-1.3;
 a:=1;
 b:=0;
 glBegin(GL_Quads);
 for i:=1 to Hero.Fire do
  begin
   gltexcoord2f(A*0.25     ,B*0.25+0.25);   glVertex2f(X+0.07+i*0.045,Y-0.07+(i mod 2)*0.03);
   gltexcoord2f(A*0.25+0.25,B*0.25+0.25);   glVertex2f(X+0.07+i*0.045,Y+0.07+(i mod 2)*0.03);
   gltexcoord2f(A*0.25+0.25,B*0.25     );   glVertex2f(X-0.07+i*0.045,Y+0.07+(i mod 2)*0.03);
   gltexcoord2f(A*0.25     ,B*0.25     );   glVertex2f(X-0.07+i*0.045,Y-0.07+(i mod 2)*0.03);
  end;
 glend;
 {bombs}
 {life}
 X:=-2;
 Y:=1.4;
 a:=1;
 b:=1;
 glBegin(GL_Quads);
 for i:=1 to Hero.Life do
  begin
   gltexcoord2f(A*0.25     ,B*0.25+0.25);   glVertex2f(X+0.04+i*0.045,Y-0.04);
   gltexcoord2f(A*0.25+0.25,B*0.25+0.25);   glVertex2f(X+0.04+i*0.045,Y+0.04);
   gltexcoord2f(A*0.25+0.25,B*0.25     );   glVertex2f(X-0.04+i*0.045,Y+0.04);
   gltexcoord2f(A*0.25     ,B*0.25     );   glVertex2f(X-0.04+i*0.045,Y-0.04);
  end;
 glend;
 glDepthMask(true);
 glDisable(GL_blend);
end;
{$ENDREGION}

{$REGION 'Render Scene'}
procedure TWorld.Render_Scene;
var 
  p:TPlane;
begin           
 glEnable(GL_CULL_FACE);
 {pozition}          
 glRotatef(AX,1,0,0);
 glRotatef(-AY,0,1,0); 
 {ligth}
 p[0]:=100; p[1]:=100; p[2]:=100; p[3]:=1;      { }
 glLightFV(Gl_LIGHT0,Gl_Position,@p);          { }
 {render scene}
 Draw_Land();
 {Hero}
 Draw_Hero();
 {enemies}
 Draw_Enemies();
 {shadows}
 if Self.Dragon_Shadowed then
  Draw_Shadow;
 {enemy shadows}
 if Self.Shadowed then
 Draw_Enemy_Shadows;
 {shadow mask}
 Render_Shadow_Mask;
 {parts}
 put_parts;
 {draw sky}

 draw_Sky;
 {HUD}
 put_HUD;
end;
{$ENDREGION}

{$REGION 'Add_Bullet'}
procedure TWorld.add_Bullet(tip: TBullet_Type; Pt: TVector3f; Vect: TVector3f; Life: Integer; Damage: Integer);
Var i:integer;
begin
 for i:=0 to Max_Bullets do
 if (Bullet[i].Life=0) then
 begin
  Bullet[i].tip:=tip;
  Bullet[i].Point:=Pt;
  Bullet[i].Vector:=Vect;
  Bullet[i].Life:=Life;
  Bullet[i].Damage:=Damage;
  break;
 end;
end;
 
{$ENDREGION}

{$REGION 'Menu'}
procedure TWorld.Render_Menu;
begin
  Menu.Render;
end;
{$ENDREGION}

{$REGION 'Render'}
procedure TWorld.Render;
begin
 case Self.Game_type of
   gt_none: ;
   gt_menu: Render_Menu;
   gt_game: Render_Scene;
 end;       
end;
{$ENDREGION}
end.
