unit GSound;

interface
uses
  Bass, LexUtils, Setup;

procedure InitGS;
const
  sound_Portal    = 1;
  sound_OK        = 2;
  sound_Not       = 3;
  sound_Boom      = 4;
  sound_Win       = 5;
  sound_Fire      = 6;


procedure PlaySound( I : Byte);
procedure TrackPlay;

implementation
const
  MofSound = 10;
var
  NSound : array[1..MofSound ] of string = ('Tele.OGG', 'OK.OGG', 'Not.OGG',
                                            'Boom.OGG', 'Win.OGG','GS2.MP3', 'GS4.MP3', 'GS2.MP3', 'GS3.MP3', 'GS4.MP3');
  S_Gn   : array[1..MofSound ] of Cardinal;
  S_Intro,
  S_MZT  : Cardinal;
  WSD    : boolean;

procedure LoadSounds;
var
  I : integer;
begin
 // S_MZT   := BASS_StreamCreateFile(False, PChar('Data\1.OGG'), 0, 0, BASS_SAMPLE_LOOP );
  S_Intro := BASS_StreamCreateFile(False, PChar('Data\Intro.OGG'), 0, 0, BASS_SAMPLE_LOOP );
  for I := 1 to MofSound do
    S_Gn[I] := BASS_StreamCreateFile(False, PChar('Data\' + NSound[I]), 0, 0, 0);

  BASS_ChannelPlay(S_Intro, TRUE);
end;

procedure TrackPlay;
begin
 { if (WSD) and (Setup.Sound > 0) then
  begin
    BASS_ChannelPlay(S_MZT, TRUE);
  end; }
end;

procedure InitGS;
begin
  if BASS_Init(-1, 44100, 0, 0, nil) then
  begin
    WSD:=true;
    LoadSounds;
  end
  else
    WSD:=false;
end;

procedure PlaySound;
begin
  if (WSD) and (Setup.Sound > 0) then
  begin
    BASS_ChannelPlay(S_Gn[I], TRUE);
  end;
end;

end.
