unit HS_Game;

interface
uses
  Omega, LexUtils, Setup;

procedure Init(BS : boolean = TRUE);
procedure Work;
procedure Draw;
var

  MofLevel : Integer;

  MohHTile : array[1..4] of byte = (28, 28, 32,32);

  LevelS : array of array[1..2] of string;

  LevelN : byte = 1;

  ShowMS :  Integer = 0;
implementation
uses
  HS_gproc, HS_Bar, HS_en, HS_Hero, HS_bullet, LTe_friend,
  HS_Map, HS_materials, HS_Procs, HS_Live, HS_Expl, GSound;
var
  DrawHelp : Boolean = True;

procedure Init;
begin
  Map.Load(LevelS[LevelN, 1]);
  GetEndXY;
  Hero.Init;
  if BS then
  begin
    PlaySound(sound_Portal);
  end;
end;

procedure Work;
type
  tRR = 0..2;
var
  P, SpM, SpA, hX : Single;

  procedure Win;
  begin
  if LevelN < MofLevel then
    begin
      Inc(LevelN);
      HS_Game.Init;
    end
    else
    begin
      TofG := 4;
      PlaySound(sound_Win);
    end;
  end;

  procedure WhatWin;
  var
    I : Integer;
  begin
    if  (Hero.P.X > Map.Cell.X*sMT - sMT )
    and (Hero.P.Y > Map.Cell.Y*sMT - sMT )
    and (Hero.P.X < Map.Cell.X*sMT + 2*sMT)
    and (Hero.P.Y < Map.Cell.Y*sMT + 2*sMT) then
    begin
      for I := 0 to Length(Enemy) - 1 do
      if Enemy[I].En then
      begin
        ShowMS := 200;
        Exit;
      end; 
      Win;
    end;
  end;
  procedure HeroDie;
  begin
    if Hero.Z < 0 then
    begin
      PlaySound(sound_Boom);
      HS_Game.Init;
    end;
    app(Hero.Z, -0.0025);
    app(Hero.R, 5);
    Hero.VR := -Hero.R;
  end;

  procedure KeyWork;
  begin
    if Omega.Key_Down(k_shift) then
    begin
      SpM := 0.04 * sMT;
      App(Hero.vR, 1);
    end
    else
      SpM := 0.02 * sMT;

    if (Key_Down(k_left))  or (Key_Down(k_a)) then
      app(Hero.fR, -0.1);

    if (Key_Down(k_right)) or (Key_Down(k_d)) then
      app(Hero.fR,  0.1);

    if (Key_Down(k_up))   or (Key_Down(k_w))  then
    begin
      app(P,  SpM);
      App(Hero.vR, 1);
    end;
    if (Key_Down(k_down)) or (Key_Down(k_s))  then
    begin
      app(P,  -SpM/2);
      Hero.St := 1;
    end;

    if (Key_Down(k_Ctrl)) then
      Hero.Fire;

  end;

  procedure HeroFly;
  begin

    if UpZ then
      KeyWork
    else
    if Hero.Z < 0.05 then
      WhatWin;

    if Key_Press(k_Z) then
      UpZ := not UpZ;
    if (Omega.Key_Press(K_Enter)) then
      Hero.Live := 0;
  end;

begin
  P := 0;
  Hero.St := 4;

  if  (Hero.Live < 1) then
    HeroDie
  else
    HeroFly;

  if Hero.R > 360  then
    Hero.R := Hero.R - 360
  else
  if Hero.R < -360 then
    Hero.R := Hero.R + 360;

  Fly(Hero.fP, P, Hero.R, Hero.fP);

  Hero.Work;

  HS_En.Work;
  HS_bullet.Work;
  Expl_Work;
  GetCameraXY;
  GetEndXY;

  if Key_Press(k_Space) then
    DrawHelp := not DrawHelp;
  if Key_Press(k_Escape) then
    TofG := 2;

  App(Map.CellR, 5);
end;

procedure Draw;
begin
  Map.Draw;
  HS_En.Draw;
  HS_bullet.Draw;
  Hero.Draw;
  Expl_Draw(0);
  //  
  Text_Draw(FontA1, (WinW - Omega.Text_GetWidth
           (FontA1, PChar(LevelS[LevelN, 2]))) / 2, 8,
                    PChar(LevelS[LevelN, 2]));

end;

end.
