unit HS_Procs;

interface
uses
  Omega, LexUtils;

procedure Init;
procedure Draw;
procedure Work;
procedure UseOpt;
var
  TofG  : Integer;
  GOn   : Boolean    = False;

  DrawInfo : Boolean = False;
  DrawColl : Boolean = False;
  MouseX, MouseY : Integer;

implementation
uses
  Windows, GSound, Setup,
  HS_Intro, HS_Menu, HS_Win, HS_Hero,
  HS_gproc, HS_En, LTe_friend,
  HS_map, HS_Materials, HS_Game, HS_console;

procedure Init;
begin
  HS_gproc.SetSize;
  HS_materials.Load;
  HS_hero.Load;
  HS_en.Load;
  HS_Map.NewMap(1,1);
  HS_Game.Init(FALSE);
  GSound.InitGS;
end;

procedure Work;
begin
  MouseX := Omega.Mouse_X;
  MouseY := Omega.Mouse_Y;

  case TofG of
    1 : HS_Intro.Work;
    2 : HS_Menu.Work;
    3 : HS_Game.Work;
    4 : HS_Win.Work;
  end;

 // HS_Expl.Work;

{  if SkyDraw then
    StormD_Sky.Work;}

  if Console then
    HS_console.Work;

  if Key_Press(k_BACKSPACE) then
    OE_Quit;
end;

procedure Info;
var
  X, I : Integer;
  InfoS : array[1..4] of string;
begin
  X := WinW - 170;
  Omega.Pr2D_Rect( X,     8, 166, 176,      15, 120, 1);
  Omega.Pr2D_Rect( X +3, 11, 160, 170, $FFFFFF, 240, 0);

  InfoS[1] := 'FPS : ' + Int2S(Omega.OE_GetFPS);
  InfoS[3] := Int2S(Length(LevelS));
  InfoS[4] := Int2S(LevelN);

  for I := 1 to 4 do
  Omega.Text_Draw(FontA1, X+8, 11 + I * 22, PChar(InfoS[I]));

  Omega.Pr2D_Rect( Gran.X, Gran.Y,
                   Gran.W - Gran.X, Gran.H - Gran.Y,
                   0, 200, 0);
end;

procedure Draw;
var
  I : integer;
begin
  Pr2D_Rect( 0, 0, WinW, WinH, sColor, 255, 1);

  case TofG of
    1 : HS_Intro.Draw;
    2 : HS_Menu.Draw;
    3 : HS_Game.Draw;
    4 : HS_Win.Draw;
  end;

//  HS_Expl.Draw;

  if DrawInfo then
    Info;
    
  if TofG > 1 then
  SSPrite_Draw(m_Cur, MouseX, MouseY, 36, 36);
end;

procedure UseOpt;
begin
  OE_ChangeScreenOptions(WinW, WinH, WinColors, 0, FullWin, ffVSync);
  Omega.OE_SetWndPosition((GetSystemMetrics(SM_CXSCREEN) - WinW) div 2,
                          (GetSystemMetrics(SM_CYSCREEN) - WinH) div 2 -20 );
  SetSize;
  HS_Menu.Init;
  HS_Game.Init(FALSE);
  Setup.SaveSetupFile;
 { StormD_Sky.cWinW := WinW;
  StormD_Sky.cWinH := WinH; }
end;

end.
