unit HS_bullet;

interface


procedure Add_Bullet(X, Y, inR, inS : Single; inT, inU : Byte; inSz : Single; Good : Byte = 1);
procedure Draw;
procedure Work;

implementation
uses
  LexUtils, LTe_friend, HS_Live, HS_en, HS_Hero, GSound,
  HS_materials, HS_gproc, HS_map;
type

  TBullet = class
    Live   : Integer;
    U,
    T      : Byte;
    Sz,
    R      : Single;
    En     : Boolean;
    S,
    P      : TM2DRealPoint;
    procedure Work1;
    procedure Work2;
    procedure Draw;
  end;

var
  Bullet : array[1..2] of array of TBullet;

procedure TBullet.Work1;
var
  I : Integer;
begin
  if (P.X < 0)
  or (P.Y < 0)
  or (P.X > Map.X * sMT)
  or (P.Y > Map.Y * sMT) then
    En := False;

  for I := 0 to length(Enemy) - 1 do
  if  (Enemy[I].En)
  and (P.X > Enemy[I].P.X - ET[Enemy[I].Tp].S.X/3)
  and (P.Y > Enemy[I].P.Y - ET[Enemy[I].Tp].S.Y/3)
  and (P.X < Enemy[I].P.X + ET[Enemy[I].Tp].S.X/3)
  and (P.Y < Enemy[I].P.Y + ET[Enemy[I].Tp].S.Y/3)
  then
  begin
    Dec(Enemy[I].Live, U);
    Expl_Add(m_expl, P.X, P.Y, 40, Int2RGB(random($15)*$FFFF + random($15)*$FF + $D0 + random($1F)), 0);
    En := False;
    PlaySound(sound_boom);
  end;

  App(P.X, S.X);
  App(P.Y, S.Y);
end;

procedure TBullet.Work2;
var
  I : Integer;
begin
  if (P.X < 0)
  or (P.Y < 0)
  or (P.X > Map.X * sMT)
  or (P.Y > Map.Y * sMT) then
    En := False;

  for I := 0 to length(Enemy) - 1 do
  if  (Enemy[I].En)
  and (P.X > Hero.P.X - sMT*0.7)
  and (P.Y > Hero.P.Y - sMT*0.7)
  and (P.X < Hero.P.X + sMT*0.7)
  and (P.Y < Hero.P.Y + sMT*0.7)
  then
  begin
    Dec(Hero.Live, U);
    Expl_Add(m_expl, P.X, P.Y, 40, Int2RGB(random($15)*$FFFF + random($15)*$FF + $D0 + random($1F)), 0);
    En := False;
    PlaySound(sound_boom);
  end;

  App(P.X, S.X);
  App(P.Y, S.Y);
end;

procedure TBullet.Draw;
begin
  Draw2D_Sprite(m_bullet, P.X - Camera.X, P.Y - Camera.Y, Sz, Sz*2, R, T);
end;

procedure Add_Bullet;
var
  I, J, L : Integer;
  MR : SIngle;
begin
  I := - 1;
  L := Length(Bullet[Good]);
  for J:=0 to L-1 do
  if not Bullet[Good, J].En then
    begin
      I := J;
      Break;
    end;
  if I=-1 then
    begin
      I:=L;
      SetLength(Bullet[Good], I+1);
    end;
  if Bullet[Good, I] = nil then
  Bullet[Good, I] := TBullet.Create;
  with Bullet[Good, I] do
  begin

    U   := inU;
    T   := inT;
    R   := inR;
    Sz:= inSz;
    P  := Set2DRealPoint(X, Y);

    MR := pi*(R - 90 )/180;
    S  := Set2DRealPoint(cos(MR)* inS, sin(MR)* inS);
    En := True;
  end;
  if Good = 1 then
    PlaySound(sound_fire)
  else
    PlaySound(sound_fire + InT);
end;

procedure Draw;
var
  I, GD : Integer;
begin
  for GD := 1 to 2 do
  for I := 0 to Length(Bullet[GD]) - 1 do
  if Bullet[GD][I].En then
    Bullet[GD][I].Draw;
end;

procedure Work;
var
  I : Integer;
begin
  for I := 0 to Length(Bullet[1]) - 1 do
  if Bullet[1][I].En then
    Bullet[1][I].Work1;
  for I := 0 to Length(Bullet[2]) - 1 do
  if Bullet[2][I].En then
    Bullet[2][I].Work2;
end;


end.
