unit HS_en;

interface
uses
  Omega, LexUtils, LTe_friend;

procedure Load;
procedure Work;
procedure Draw;
function  Enemy_add(X, Y : Single; T : Byte = 1) : Integer;

type
  TET = record
    Live : Integer;
    S : TM2DRealPoint;
    FS : Integer;
    TMR,
    U : Byte;
    BSc,
    BSz : Single;
  end;

  Tenemy = class
    P : TM2DRealPoint;
    St,
    Tmr,
    Tp : Byte;
    Live : Integer;
    An,
    R : Single;
    En,
    D : Boolean;
    procedure Work;
    procedure Draw;
  end;

const
  MofTEn = 4;
var
  Enemy : array of Tenemy;
  ET : array[1..MofTEn] of TET;
  
implementation
uses
  HS_bullet,
  HS_gproc, HS_Live, HS_hero, HS_materials;

var
  m_enemy : array[1..MofTEn] of array[1..2] of tLXMaterial;
  

procedure Load;
var
  I, J : Integer;
begin
  for I := 1 to MofTEn do
  for J := 1 to 2 do
    m_enemy[I, J] := Texture_Load('Data\en_' + Int2S(I) + Int2S(J) + '.JPG',
                                  'Data\en_' + Int2S(I) + Int2S(J) + '_m.GIF');
  ET[1].Live := 20;
  ET[1].S := Set2dRealPoint(SMt*0.9, SMt*0.9);
  ET[1].U := 15;
  ET[1].TMR := 70;
  ET[1].FS := 14;

  ET[2].Live := 80;
  ET[2].S := Set2dRealPoint(SMt*2, SMt*2);
  ET[2].U := 5;
  ET[2].TMR := 45;
  ET[2].FS := 45;

  ET[3].Live := 150;
  ET[3].S := Set2dRealPoint(SMt*3, SMt*2.5);
  ET[3].U := 15;
  ET[3].TMR := 35;
  ET[3].FS := 64;

  ET[4].Live := 200;
  ET[4].S := Set2dRealPoint(SMt*2, SMt*2);
  ET[4].U := 20;
  ET[4].TMR := 60;
  ET[4].FS := round(Smt/3);

  ET[1].BSZ := 26;
  ET[2].BSZ := 22;
  ET[3].BSZ := 22;
  ET[4].BSZ := 35;

  ET[1].BSc := 4;
  ET[2].BSc := 5;
  ET[3].BSc := 6;
  ET[4].BSc := 3;
  Pattern_Set(m_enemy[1, 1].PatternN, 8, 1);

end;

function Enemy_add;
var
  L : Integer;
begin
  L := Length(Enemy);
  SetLength(Enemy, L + 1);
  Enemy[L] := TEnemy.Create;
  with Enemy[L] do
  begin
    P    := Set2dRealPoint(X * sMT  + sMT/2, Y * sMT  + sMT/2);
    St   := 1;
    Tmr  := 0;
    Tp   := T;
    Live := ET[T].Live;
    R    := random(360);
    En := True;
  end;
  Result := L + 1;
end;

//______________________________________________________________________________
procedure Tenemy.Work;
var
  MR  : single;
begin
  R := whatroll(Hero.P.X + 0.5*sMT, P.X, Hero.P.Y + 0.5*sMT, P.Y) + 180;

  if R > 360  then
    R := R - 360
  else
  if R < -360 then
    R := R + 360;

   if Tmr > 0 then
    Dec(Tmr);

   if (D) then
   begin
    if An < 8 then
      App(An, 0.33)
    else
      D := False;
    end;

  if (Tmr = 0)
  and (M_Distance(P.X, P.Y, Hero.P.X, Hero.P.Y) < 10*sMT) then
  begin
    Tmr := ET[Tp].TMR;
    D   := True;
    An  := 1;
    MR := pi*(R - 90 )/180;
    Add_Bullet(P.X + cos(MR)*ET[Tp].FS*1.8, P.Y + sin(MR)*ET[Tp].FS*1.8, R - 2 + random(9)/2, ET[Tp].BSC, Tp, 5, ET[Tp].BSZ + random(5), 2)
  end;

  if Live < 1 then
  begin
    Expl_Add(m_Expl, P.X, P.Y, ET[Tp].S.X, Int2RGB($FF), 0);
    En := False;
  end;
end;

procedure Tenemy.Draw;
var
  MR  : Single;
  iR  : Integer;
begin
  if En then
  begin
  //  if D then
      

  case Tp of
    1 : begin
          iR := round(R) div 45;
          color_use(Int2RGB(0));
          Draw2D_Sprite(M_enemy[Tp, 1], P.X - Camera.X - 5, P.Y - Camera.Y + 5, ET[Tp].S.X + 10, ET[Tp].S.Y + 5, 0, iR + 1, 0.4 );
          color_clear;
          Draw2D_Sprite(M_enemy[Tp, 1], P.X - Camera.X , P.Y - Camera.Y, ET[Tp].S.X, ET[Tp].S.Y, 0, iR + 1 );
          if D then
          begin
            MR := pi*(iR - 90 )/180;
            Draw2D_Sprite(m_fire, P.X - Camera.X + cos(MR)*ET[Tp].FS, P.Y - Camera.Y + sin(MR)*ET[Tp].FS, 10, 80, iR * 45, Round(An));
          end;
        end;
    2 : begin
          color_use(Int2RGB(0));
          Draw2D_Sprite(M_enemy[Tp, 1], P.X - Camera.X - 5, P.Y - Camera.Y + 5, ET[Tp].S.X + 10, ET[Tp].S.Y + 7, 0, 0, 0.4 );
          color_clear;
          Draw2D_Sprite(M_enemy[Tp, 1], P.X - Camera.X, P.Y - Camera.Y, ET[Tp].S.X, ET[Tp].S.Y );
          Draw2D_Sprite(M_enemy[4,  2], P.X - Camera.X, P.Y - Camera.Y, 180, 90, R);
          if D then
          begin
            MR := pi*(R - 90 )/180;
            Draw2D_Sprite(m_fire, P.X - Camera.X + cos(MR)*ET[Tp].FS, P.Y - Camera.Y + sin(MR)*ET[Tp].FS, 12, 96, R, Round(An));
          end;
        end;
    3 : begin
          color_use(Int2RGB(0));
          Draw2D_Sprite(M_enemy[Tp, 1], P.X - Camera.X    , P.Y - Camera.Y + sMT    , ET[Tp].S.X   + 10, ET[Tp].S.X - sMT*1.5, 0, 0, 0.4);
          Draw2D_Sprite(M_enemy[Tp, 2], P.X - Camera.X - 5, P.Y - Camera.Y + sMT/2.5, ET[Tp].S.Y/2 + 10, ET[Tp].S.Y + 10     , R, 0, 0.4 );
          color_clear;
          Draw2D_Sprite(M_enemy[Tp, 1], P.X - Camera.X, P.Y - Camera.Y + sMT/1.5, ET[Tp].S.X  , ET[Tp].S.X, 0 );
          Draw2D_Sprite(M_enemy[Tp, 2], P.X - Camera.X, P.Y - Camera.Y          , ET[Tp].S.Y/2, ET[Tp].S.Y, R );
          if D then
          begin
            MR := pi*(R - 90 )/180;
            Draw2D_Sprite(m_fire, P.X - Camera.X + cos(MR)*ET[Tp].FS, P.Y - Camera.Y + sin(MR)*ET[Tp].FS, 32, 256, R, Round(An));
          end;
        end;
    4 : begin
          color_use(Int2RGB(0));
          Draw2D_Sprite(M_enemy[Tp, 1], P.X - Camera.X - 5, P.Y - Camera.Y + 5, ET[Tp].S.X + 10, ET[Tp].S.Y + 7, R, 0, 0.4 );
          color_clear;
          Draw2D_Sprite(M_enemy[Tp, 1], P.X - Camera.X, P.Y - Camera.Y, ET[Tp].S.X, ET[Tp].S.Y, R );
        end;  
  end;
  end
  else
  begin
  if Tp = 1 then
    Draw2D_Sprite(M_blood, P.X - Camera.X, P.Y - Camera.Y, ET[Tp].S.X + 12, ET[Tp].S.Y + 12, R, 0, 0.8 )
  else
    Draw2D_Sprite(M_fw   , P.X - Camera.X, P.Y - Camera.Y, ET[Tp].S.X + 18, ET[Tp].S.Y + 18, R, 0, 0.7 );
  case Tp of
    1 : begin
          color_use(Int2RGB(0));
          Draw2D_Sprite(M_enemy[Tp, 2], P.X - Camera.X - 5, P.Y - Camera.Y + 5, ET[Tp].S.X + 18, ET[Tp].S.Y + 13, 0, 0, 0.4 );
          color_clear;
          Draw2D_Sprite(M_enemy[Tp, 2], P.X - Camera.X , P.Y - Camera.Y, ET[Tp].S.X + 8, ET[Tp].S.Y + 8 );
        end;
    2 : begin
          color_use(Int2RGB(0));
          Draw2D_Sprite(M_enemy[Tp, 2], P.X - Camera.X - 5, P.Y - Camera.Y + 5, ET[Tp].S.X + 10, ET[Tp].S.Y + 7, 0, 0, 0.4 );
          color_clear;
          Draw2D_Sprite(M_enemy[Tp, 2], P.X - Camera.X, P.Y - Camera.Y, ET[Tp].S.X, ET[Tp].S.Y );
        end;
    3 : begin
          color_use(Int2RGB(0));
          Draw2D_Sprite(M_enemy[Tp, 1], P.X - Camera.X    , P.Y - Camera.Y + sMT    , ET[Tp].S.X   + 10, ET[Tp].S.X - sMT*1.5, 0, 0, 0.4);
          color_clear;
          Draw2D_Sprite(M_enemy[Tp, 1], P.X - Camera.X, P.Y - Camera.Y + sMT/1.5, ET[Tp].S.X  , ET[Tp].S.X, 0 );
        end;
    4 : begin
          color_use(Int2RGB(0));
          Draw2D_Sprite(M_enemy[Tp, 1], P.X - Camera.X - 5, P.Y - Camera.Y + 5, ET[Tp].S.X + 10, ET[Tp].S.Y + 7, R, 0, 0.4 );
          color_use(Int2RGB($202020));
          Draw2D_Sprite(M_enemy[Tp, 1], P.X - Camera.X, P.Y - Camera.Y, ET[Tp].S.X, ET[Tp].S.Y, R );
          color_clear;

        end;  
  end;
  end;
end;
//______________________________________________________________________________
procedure Work;
var
  I : Integer;
begin
  for I := 0 to Length(Enemy) - 1 do
  if Enemy[I].En then
    Enemy[I].Work;
end;

procedure Draw;
var
  I : Integer;
begin
  for I := 0 to Length(Enemy) - 1 do
    Enemy[I].Draw;
end;
end.
