unit HS_hero;
interface
uses
  LTe_friend;

procedure Load;

const
  MofHG = 5;
type
  THGun = record
    P : TM2DRealPoint;
    Tmr : Byte;
    Alpha,
    An : Single;
    D,
    E : Boolean;
  end;

  THero = class
    P,                   //( f - force )
    fP : TM2DRealPoint;
    Z,
    R,
    fR,
    vR : Single;
    VSt,
    St : Byte;
    Live : Integer;
    HGun : array[1..MofHG] of THGun;
    procedure Init;
    procedure Work;
    procedure Draw;
    procedure Fire;
  end;
var
  Hero : THero;
  UpZ : Boolean = True;
  m_fire :tLxMaterial;
implementation
uses
  LexUtils, Omega, HS_map, HS_bullet,
  HS_gproc, OpenGL;
 
const
  MaxZ = 0.1;
var
  m_vint : array[1..2] of tLxMaterial;
  m_hero : tLxMaterial;

  Sz : Single = 0.5;
  W, H : single;

procedure Load;
begin
  
  m_hero    := Texture_Load('Data\hc.GIF',    'Data\hc_m.GIF');
  m_vint[1] := Texture_Load('Data\hv.JPG',    'Data\hv_m.JPG');
  m_vint[2] := Texture_Load('Data\hv.JPG',    'Data\hzv_m.JPG');
  m_fire    := Texture_Load('Data\fire.JPG',  'Data\fire_m.JPG');
  Pattern_Set(m_hero.PatternN, 4, 1);
  Pattern_Set(m_fire.PatternN, 8, 1);
  H := 3.2 * sMT;
  W := H/2;
  Hero := Thero.Create;
end;


procedure THero.Init;
var
  I : Integer;
begin
  with Map do
  begin
    P  := Set2DRealPoint(SHero.P.X * sMT - sMT/2, SHero.P.Y * sMT + sMT/2);
    FP := Set2DRealPoint(0, 0);
    R  := SHero.R;
    fR := 0;
    vR := 0;
    Z  := 0.1;//SHero.Z;
    St := 1;
    VSt := 1;
    Live := 1000;
  end;

  for I := 1 to MofHG do
  with HGun[I] do
  begin
    E     := True;
    An    := 1;
    Tmr   := 0;
    Alpha := 1;
  end;

  HGun[1].P := Set2DRealPoint(   0, -0.25);
  HGun[2].P := Set2DRealPoint(-0.2, -0.05);
  HGun[3].P := Set2DRealPoint( 0.2, -0.05);
 { HGun[4].P := Set2DRealPoint( ,);
  HGun[5].P := Set2DRealPoint( ,); }

end;

procedure THero.Fire;
var
  I : Integer;
  MR, X, Y : Single;
begin
  MR := pi*(R - 90 )/180;
  X := P.X;
  Y := P.Y;
  for I := 1 to MofHG do
  with HGun[I] do
  if Tmr = 0 then
  begin
    Tmr := 25;
    D   := True;
    An  := 1;
    Add_Bullet(P.X*W + X, P.Y*H + Y, R - 2 + random(9)/2, SMT/10, 2, 5, 10 + random(4))
  end;

end;

procedure THero.Work;
var
  Test : TM2DRealPoint;
  I : Integer;
begin
//  St := 4;

  if abs(fR) > 0.05 then
    App(R, fR);

  Test := P;
  if abs(fP.X) > 0.05 then
  begin
    App(Test.X, fP.X);
  end;
  if abs(fP.Y) > 0.05 then
  begin
    App(Test.Y, fP.Y);
  end;

  if UpZ then
  begin
  if  (Test.X > 4 * sMT)
  and (Test.X < (Map.X - 3) * sMT)
  then
    P.X := Test.X;

  if  (Test.Y > 4 * sMT)
  and (Test.Y < (Map.Y - 3) * sMT)
  then
    P.Y := Test.Y;
  end;
  if fR < -0.7 then
    St := 2
  else
  if fR > 0.7 then
    St := 3;
  //____________________________________________________________________________
  if fP.X >  0.7 then
    fP.X :=  0.7
  else
  if fP.X < -0.7 then
    fP.X := -0.7
  else
  if fP.X > 0 then
    App(fP.X, -0.002)
  else
  if fP.X < 0 then
    App(fP.X,  0.002);

  if fP.Y >  0.7 then
    fP.Y :=  0.7
  else
  if fP.Y < -0.7 then
    fP.Y := -0.7
  else
  if fP.Y > 0 then
    App(fP.Y, -0.002)
  else
  if fP.Y < 0 then
    App(fP.Y,  0.002);

  if fR > 0 then
    App(fR, -0.05)
  else
  if fR < 0 then
    App(fR,  0.05);


  if UpZ then
  begin
    if Z < MaxZ then
    begin
      App(Z, 0.001);
      App(VR, Z*100);
    end;
  end
  else
  begin
    if Z > 0 then
    begin
      App(Z, -0.001);
      App(VR, Z*100);
    end;
  end;

  if Z >= MaxZ then
  begin
    App(VR, 4.5);
    VSt := 1;
  end
  else
    VSt := 2;

  if VR > 360  then
    VR := VR - 360
  else
  if VR < -360 then
    VR := VR + 360;

 for I := 1 to MofHG do
 with HGun[I] do
 begin
   if Tmr > 0 then
    Dec(Tmr);

   if (D) then
   begin
    if An < 8 then
      App(An, 0.33)
    else
      D := False;
    end;
 end;

end;

procedure THero.Draw;
var
  I : Integer;
begin
  glPushMatrix;
  //____________________________________________________________________________
  with P do
    glTranslated(X - 10 - Camera.X, Y + 5 - Camera.Y, 0);

  OpenGL.glRotatef(R, 0, 0, 1);
  glScaled (W, H, 1.0);
  glColor4f(0, 0, 0, 0.5);
  Draw2D_ESprite(m_hero, St, 0.55 + 1.5*Z);
  glColor4f(1, 1, 1, 1);
  //____________________________________________________________________________
  glPopMatrix;

  glPushMatrix;
  //____________________________________________________________________________

  with P do
    glTranslated(X - Camera.X, Y - Z*H - Camera.Y, 0);

  OpenGL.glRotatef(R, 0, 0, 1);
  
  glScaled (W, H, 1.0);

  for I :=1 to MofHG do
  with HGun[I] do
  if D then
  begin
    glTranslated(  P.X ,  P.Y , 0);
    glScaled (1,   4, 1);
    glColor4f(1, 1, 1, 1 - An*0.05);
    Draw2D_ESprite(m_fire, Round(An), 0.07 );
    glColor4f(1, 1, 1, 1);
    glScaled (1, 1/4, 1);
    glTranslated( -P.X , -P.Y , 0);
  end;

  Draw2D_ESprite(m_hero, St, 0.5 + Z);
  glScaled (2, 1, 1);
  OpenGL.glRotatef(VR, 0, 0, 1);
  Draw2D_ESprite(m_vint[VSt], 0, 0.5 + Z);
  OpenGL.glRotatef(VR, 0, 0, -1);
  //____________________________________________________________________________
  glPopMatrix;
end;



end.
