unit HS_map;

interface
uses
  LexUtils, Setup, Omega, LTe_friend;

const
  sColor = $0F0F0F;

type
  tTile = record
    T,    // 
    M,    // 
    A   : Byte;
  end;

  tTop  = record
    Tile : array[1..2] of tTile;
    S1, S2  : Byte;
  end;

  TSHero = record
    P : TM2DPoint;
    R : Integer;
    Z : Single;
  end;
  tMap = class
    Top   : array of array of tTop;
    X, Y  : Integer;
    SHero : TSHero;
    Cell  : TM2DPoint;
    CellR : Single;
    procedure Size(inX, inY : Integer);
    procedure Draw;
    procedure Load(FileName : String);
  end;

var
  Map     : TMap;

procedure NewMap(X : Integer = 10; Y : Integer = 10);

implementation
uses
  HS_en,
  HS_gproc, HS_materials;

procedure tMap.Size;
begin
  X := InX - 1;
  Y := InY - 1;
  SetLength(Map.Top, inX, inY);
end;

procedure tMap.Draw;
var
  iX, iY,  J   : Integer;
begin
  for iX := startX to endX do
  for iY := startY to endY do
  begin
    for J := 1 to 2 do
    with Top[iX, iY].Tile[J] do
    if  (T > 0)
    and (M > 0) then
      SSprite_Draw(m_Tile[T, M], iX*sMT - Camera.X, iY*sMT - Camera.Y, sMT, sMT );
  end;

  SSprite_Draw(m_cell, Cell.X*sMT - Camera.X, Cell.Y*sMT - Camera.Y, sMT, sMT, 200, cellR );
end;



procedure tMap.Load;
type
  tDummyEn = record
    P : TM2DPoint;
    T : Byte;
  end;
var
  F : file;
  I, iX, iY : Integer;
  DummyEn : tDummyEn;
begin
  AssignFile(F, FileName);
  Reset(F, 1);
  BlockRead(F, X, SizeOf(Integer));
  BlockRead(F, Y, SizeOf(Integer));
  Size(X + 1, Y + 1);
  SetLength(Enemy, 0);

  for iX := 0 to X do
  for iY := 0 to Y do
    BlockRead(F, Top[iX, iY], SizeOf(tTop));

  BlockRead(F, SHero, SizeOf(SHero));
  BlockRead(F, Cell, SizeOf(TM2DPoint));

  BlockRead(F, IX, SizeOf(Integer));

  for I := 0 to IX - 1 do
  begin
    BlockRead(F, DummyEn, SizeOf(tDummyEn));
    Enemy_Add(DummyEn.P.X, DummyEn.P.Y, DummyEn.T )
  end;

  CloseFile(F);
end;

procedure NewMap;
begin
  if Map <> nil then
    Map.Free;
  Map := tMap.Create;
  Map.Size(X, Y);
end;

end.
