unit HS_menu;

interface

  procedure Draw;
  procedure Work;
  procedure Init;
var
  fWinW, fWinH : Integer;
  ffVSync : Boolean;
implementation
uses
  Omega, Setup, HS_Procs, HS_Materials, HS_bar,
 HS_game, LexUtils,
  GSound;

type
  tMenuButton = class( tBarButton)
    NS : string;
    procedure Draw;
  end;

const
  MofMB = 5;
  MofOB = 8;

type
  tMenu = class
    MenuButton   : array[1..MofMB] of tMenuButton;
    LevelButton  : array of tMenuButton;
    OptionButton : array[1..MofOB] of tMenuButton;
    procedure Draw;
    procedure Work;
    procedure GetOpt;
    procedure GetRealOpt;
    procedure Init;
  end;

var
  Menu : tMenu;

  MenuSost : Byte = 1;
  MenuBNS : array[1..MofMB] of string= (' ', '', '', '', '');

  OptBNS  : array[1..MofOB] of string= ('800x600', '1024x768', '1280x800', '1280x1024',
                                        ' ',
                                        ' ',
                                        '', '');



procedure tMenu.GetOpt;
var
  I : Integer;
begin
  for I := 1 to MofOB do
  OptionButton[I].NS := OptBNS[I];

  if (fWinW = 800)  and (fWinH = 600) then  I := 1 else
  if (fWinW = 1024) and (fWinH = 768) then  I := 2 else
  if (fWinW = 1280) and (fWinH = 800) then  I := 3 else
  if (fWinW = 1280) and (fWinH = 1024) then I := 4 else I := 0;

  if I > 0 then
    OptionButton[I].NS := '&' + OptBNS[I] + '&';

  if FullWin then
    OptionButton[5].NS := '&   #';

  if VSync then
    OptionButton[6].NS := '& ' + OptBNS[6] + ' &';

end;

procedure tMenu.GetRealOpt;
begin
  fWinW  := WinW;
  fWinH  := WinH;

end;

procedure tMenu.Init;
var
  sBW  : single;
  I, S : Integer;
begin
  sBW := WinW / (MofMB + 1);
  for I := 1 to MofMB do
  MenuButton[I] := tMenuButton.Create;
  for I := 1 to MofMB do
  with MenuButton[I] do
  begin
    X := round(I * sBW - sBW / 2);
    Y := round(WinH - sBW / 2);
    W := round(sBW-8);
    H := round(sBW / 3);
    NS := MenuBNS[I];
  end;

  SetLength( LevelButton, MofLevel + 1);
  for I := 1 to MofLevel do
  LevelButton[I] := tMenuButton.Create;

  sBW := sBW * 2;
  S := MofLevel div 2 + 1;

  for I := 1 to S do
  with LevelButton[I] do
  begin
    X := round((WinW / 2) - sBW);
    Y := round(I * sBW / 5);
    W := round(sBW - 16);
    H := round(sBW / 6);
    NS := LevelS[I, 2];
  end;

  for I := S + 1 to MofLevel do
  with LevelButton[I] do
  begin
    X := round(WinW / 2) + 8;
    Y := round((I - S) * sBW / 5);
    W := round(sBW - 16);
    H := round(sBW / 6);
    NS := LevelS[I, 2];
  end;

  for I := 1 to MofOB do
  OptionButton[I] := tMenuButton.Create;

  sBW := WinW / 5;
  for I := 1 to 4 do
  with OptionButton[I] do
  begin
    X := round(I * sBW - sBW / 2);
    Y := round(sBW / 2);
    W := round(sBW - 16);
    H := round(sBW / 5.5);
  end;

  sBW := WinW / 2.2;
  for I := 5 to 6 do
  with OptionButton[I] do
  begin
    X := round((WinW - sBW) / 2);
    Y := round(OptionButton[1].Y + 8 + (sBW / 10 + 8) * (I - 4) );
    W := round(sBW - 16);
    H := round(sBW / 10);
  end;

  sBW := WInW / 3;
  for I := 7 to 8 do
  with OptionButton[I] do
  begin
    Y := round(OptionButton[6].Y + 3.5 * OptionButton[6].H);
    W := round(sBW - 16);
    H := round(sBW / 7);
    OptionButton[I].NS := OptBNS[I];
  end;
  OptionButton[7].X := round( WinW / 2 - sBW);
  OptionButton[8].X := round( WinW / 2 + 16);
  GetRealOpt;
  GetOpt;
end;

procedure tMenu.Draw;
var
  I : Integer;
begin
  for I := 1 to MofMB do
    MenuButton[I].Draw;

  case MenuSost of
  // 
    1 : SSprite_Draw(m_HSName, (WinW - 512)/2, WinH/2 - 128, 512, 128);
  // 
    2 : for I := 1 to MofLevel do
          LevelButton[I].Draw;
  // 
    3 : for I := 1 to MofOB do
          OptionButton[I].Draw;
  end;
end;

procedure tMenu.Work;
var
  I, BLevel,
  iDo : Integer;
begin
  iDo := 0;
  BLevel := 1;
  //   ___________________________________________________________________
  for I := 1 to MofMB do
  if (MenuButton[I].MouseInB) then
    iDo := 10 + I;

  case MenuSost of
  //  __________________________________________________________________
    2 : for I := 1 to MofLevel do
        if (LevelButton[I].MouseInB) then
        begin
          BLevel := I;
          iDo := 20;
        end;
  //  _____________________________________________________________________
      3 : for I := 1 to MofOB do
        if (OptionButton[I].MouseInB) then
          iDo := 30 + I;
   end;
  //____________________________________________________________________________
  if  (iDo > 0)
  and (Mouse_Click(M_LBUTTON)) then
  begin
    PlaySound(sound_NOT);
    case iDo of
    //  
      11 :  begin
              HS_game.LevelN := 1;
              HS_game.Init;
              TofG := 3;
              GOn := True;
            end;
      12 :  if GOn then TofG := 3;
      13 :  MenuSost := 2;
      14 :  MenuSost := 3;
      15 :  OE_Quit;
    // 
      20 :  begin
              HS_game.LevelN := BLevel;
              HS_game.Init;
              TofG := 3;
              GOn := True;
            end;
    // 
      31 : begin
             fWinW := 800;
             fWinH := 600;
           end;
      32 : begin
             fWinW := 1024;
             fWinH := 768;
           end;
      33 : begin
             fWinW := 1280;
             fWinH := 800;
           end;
      34 : begin
             fWinW := 1280;
             fWinH := 1024;
           end;
      35 : FullWin := not FullWin;
      36 : VSync   := not VSync;
      37 : begin
             WinW := fWinW;
             WinH := fWinH;
             UseOpt;
           end;
      38 : begin
             Setup.LoadSetupFile;
             GetRealOpt;
             MenuSost := 1;
           end;
    end;

    if iDo > 30 then
      GetOpt;
  end;

  Omega.Key_Press(k_Space);
  if Key_Press(k_Escape) then
  begin

    if GOn then
      TofG := 3
    else
    MenuSost := 1;
    //OE_Quit;
  end;
end;

procedure tMenuButton.Draw;
begin
  if MD then
    Pr2D_Rect(X + 3, Y + 7, W - 6, H - 14, $F0F0F0, 140, 1);
  Pr2D_Rect(X, Y, W, H, $705050, 150, 1);
  Pr2D_Rect(X, Y, W, H, $FFFFFF, 170, 0);

  Text_Draw(FontA1, X + (W - Text_GetWidth
           (FontA1, PChar(NS), 0.9)) / 2, Y + (H-24)/2,
                    PChar(NS), 0.9);
end;

procedure Init;
begin
  if Menu <> nil then
    Menu.Free;
  Menu := tMenu.Create;
  Menu.Init;
end;

procedure Work;
begin
  Menu.Work;
end;

procedure Draw;
begin
  Menu.Draw
end;

end.

