unit LTe_friend;
// LTe_friend. cdmlex (c) 2009
//   Omega;
interface

const
  cdml_lib = 'DLL\LTe_friend.dll';
  HVersion = 01;

// LexUtils
  function  Int2PC  (I : integer)              : PChar;     stdcall; external cdml_lib;
  function  S2Int   (S : string)               : Integer;   stdcall; external cdml_lib;
  function  FileEx  (FileName : string)        : Boolean;   stdcall; external cdml_lib;

//Setup
  procedure LoadSetupFile;                                stdcall; external cdml_lib;
  procedure SaveSetupFile;                                stdcall; external cdml_lib;
  procedure AddParam_B(pName : string; pValue : Boolean); stdcall; external cdml_lib;
  procedure AddParam_I(pName : string; pValue : Integer); stdcall; external cdml_lib;
  procedure AddParam_S(pName, pValue : string);           stdcall; external cdml_lib;

const
  c_s_WinW      = -3;
  c_s_WinH      = -2;
  c_s_WinColors = -1;
  c_s_FullWin   = -1;
  c_s_WrLog     = -2;

  function GetParam_B(pN : Integer) : Boolean;            stdcall; external cdml_lib;
  function GetParam_I(pN : Integer) : Integer;            stdcall; external cdml_lib;
  function GetParam_S(pN : Integer) : string;             stdcall; external cdml_lib;

  procedure SetParam_B(pN : Integer; pValue : Boolean);   stdcall; external cdml_lib;
  procedure SetParam_I(pN : Integer; pValue : Integer);   stdcall; external cdml_lib;
  procedure SetParam_S(pN : Integer; pValue : string);    stdcall; external cdml_lib;

// Color ____________________________________________________________________________
  type
    TLXGL_Color = record
      R, G, B : Single;
    end;

  function  Int2RGB( I : Integer) : TLXGL_Color; stdcall; external cdml_lib;
  procedure Color_Use(C : TLXGL_Color);          stdcall; external cdml_lib;
  procedure Color_Clear;                         stdcall; external cdml_lib;


// Materials_________________________________________________________________________
  type
    tLxMaterial = record
      Tex_ID    : Cardinal;
      W, H      : Word;
      PatternN  : Cardinal;
    end;

  function  Texture_Add (Tex_ID : Cardinal; W, H      : Word) : tLxMaterial;     stdcall; external cdml_lib;
  function  Texture_Load(Texture_Name : string; Mask_Name : string = '') : tLxMaterial;
  procedure Pattern_Set( N : Cardinal ; pkX, pkY : word);                       stdcall; external cdml_lib;
  procedure Pattern_Add( Material : tLxMaterial; X, Y, W, H : Word);            stdcall; external cdml_lib;

// Draw objects_______________________________________________________________________
  procedure Draw2D_Sprite (Material : tLxMaterial; X, Y, H, W : Single; R : Single = 0;
                               Frag : Byte = 0; Alpha : Single = 1; Sx : Single = 0.5); stdcall; external cdml_lib;
  procedure Draw2D_ESprite(Material : tLxMaterial; Frag : Byte; Sx : Single = 0.5);     stdcall; external cdml_lib;

// Sky________________________________________________________________________________
  function  Sky_Add(Material : tLxMaterial; CloudsQuantity : Word = 20; Wind : Integer = 90;
                    CloudsSizeX : Single = 256; CloudsSizeY : Single = 128;
                    W : Word = 1024; H : Word = 768; AlSp : Single = 0.0005) : Byte;
                                              stdcall; external cdml_lib;
  procedure Sky_Work(Sky_N : byte);           stdcall; external cdml_lib;
  procedure Sky_All_Work;                     stdcall; external cdml_lib;
  procedure Sky_Draw(Sky_N : byte);           stdcall; external cdml_lib;
// Expl_______________________________________________________________________________
  function  Expl_Add  (Material : tLxMaterial; X, Y, inS : Single;
                     Color : TLXGL_Color; Layer : Integer = - 1) : Word; stdcall; external cdml_lib;
  procedure Expl_Draw (Layer : Word = 0) ; stdcall; external cdml_lib;
  procedure Expl_Work;                     stdcall; external cdml_lib;


// Point
type
  TM2DRealPoint = record
    X, Y : Single;
  end;
  TM2DPoint = record
    X, Y : Integer;
  end;

  function Set2DRealPoint(X, Y : Single) : TM2DRealPoint; stdcall; external cdml_lib;
  function Set2DPoint(X, Y : Integer) : TM2DPoint;        stdcall; external cdml_lib;
  procedure Camera_Set( inCamera : TM2DRealPoint);        stdcall; external cdml_lib;
implementation
uses
  Omega;

function  Texture_Load;
var
  T : Omega.PTexture;
begin
  if Mask_Name = '' then
    T := Tex_LoadFromFile(PChar(Texture_Name), -1, TEX_DEFAULT_2D)
  else
  begin
    Tex_LoadMaskFromFile(PChar(Mask_Name));
    T := Tex_LoadFromFile(PChar(Texture_Name), -1, TEX_DEFAULT_2D or TEX_USEMASK);
  end;
  Result := Texture_Add(T.ID, T.Width, T.Height);
end;

end.
